package org.cte.ABCD.compiler.tests;

import java.io.File;
import java.io.FilenameFilter;

import org.cte.ABCD.compiler.Compiler;
import org.cte.ABCD.model.declarations.ABCDSystem;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.assertTrue;

public class ABCDCompilerTests {	
	@Test public void test0() { assertFile(new File("./examples/example1-RW.abcd").getPath()); }
	@Test public void test1() { assertFile(new File("./examples/example10-stmt.abcd").getPath()); }
	@Test public void test2() { assertFile(new File("./examples/example11-par.abcd").getPath()); }
	@Test public void test3() { assertFile(new File("./examples/example12-min.abcd").getPath()); }
	@Test public void test4() { assertFile(new File("./examples/example13-send_receive.abcd").getPath()); }
	@Test public void test5() { assertFile(new File("./examples/example14-counter.abcd").getPath()); }
	@Test public void test6() { assertFile(new File("./examples/example15_multicoms.abcd").getPath()); }
	@Test public void test7() { assertFile(new File("./examples/example16_local_mutex.abcd").getPath()); }
	@Test public void test8() { assertFile(new File("./examples/example16_mutex.abcd").getPath()); }
	@Test public void test9() { assertFile(new File("./examples/example16_nolock_mutex.abcd").getPath()); }
	@Test public void test10() { assertFile(new File("./examples/example16_notused_mutex.abcd").getPath()); }
	@Test public void test11() { assertFile(new File("./examples/example2-commSync.abcd").getPath()); }
	@Test public void test12() { assertFile(new File("./examples/example3-commASync.abcd").getPath()); }
	@Test public void test13() { assertFile(new File("./examples/example3_async_2chan_b.abcd").getPath()); }
	@Test public void test14() { assertFile(new File("./examples/example3_async_2chan_bnb.abcd").getPath()); }
	@Test public void test15() { assertFile(new File("./examples/example3_async_2chan_nb.abcd").getPath()); }
	@Test public void test16() { assertFile(new File("./examples/example3_async_block.abcd").getPath()); }
	@Test public void test17() { assertFile(new File("./examples/example3_async_noblock.abcd").getPath()); }
	@Test public void test18() { assertFile(new File("./examples/example3_async_sync.abcd").getPath()); }
	@Test public void test19() { assertFile(new File("./examples/example3_async_sync_noblock.abcd").getPath()); }
	@Test public void test20() { assertFile(new File("./examples/example4-comput.abcd").getPath()); }
	@Test public void test21() { assertFile(new File("./examples/example5-prodCons.abcd").getPath()); }
	@Test public void test22() { assertFile(new File("./examples/example5_prodCons_nomulti.abcd").getPath()); }
	@Test public void test23() { assertFile(new File("./examples/example6-stack.abcd").getPath()); }
	@Test public void test24() { assertFile(new File("./examples/example7-mutex.abcd").getPath()); }
	@Test public void test25() { assertFile(new File("./examples/example7-semaphore.abcd").getPath()); }
	@Test public void test26() { assertFile(new File("./examples/example7_local_semaphore.abcd").getPath()); }
	@Test public void test27() { assertFile(new File("./examples/example7_notused_semaphore.abcd").getPath()); }
	@Test public void test28() { assertFile(new File("./examples/example8-types.abcd").getPath()); }
	@Test public void test29() { assertFile(new File("./examples/example9-expressions.abcd").getPath()); }
	@Test public void test30() { assertFile(new File("./examples/example_async_chan.abcd").getPath()); }
	@Test public void test31() { assertFile(new File("./examples/example_defer_lowlevel.abcd").getPath()); }
	@Test public void test32() { assertFile(new File("./examples/example_endloop.abcd").getPath()); }
	@Test public void test33() { assertFile(new File("./examples/example_fct1.abcd").getPath()); }
	@Test public void test34() { assertFile(new File("./examples/example_fifo_ops.abcd").getPath()); }
	@Test public void test35() { assertFile(new File("./examples/example_foreach.abcd").getPath()); }
	@Test public void test36() { assertFile(new File("./examples/example_ping_pong.abcd").getPath()); }
	@Test public void test37() { assertFile(new File("./examples/example_portmap.abcd").getPath()); }
	@Test public void test38() { assertFile(new File("./examples/example_sync_chan.abcd").getPath()); }
	@Test public void test39() { assertFile(new File("./examples/example_while.abcd").getPath()); }
	@Test public void test40() { assertFile(new File("./examples/timer_api.abcd").getPath()); }
	@Test public void test41() { assertFile(new File("./examples/timer_api_local.abcd").getPath()); }
	@Test public void test42() { assertFile(new File("./examples/timer_api_shared.abcd").getPath()); }
	@Test public void test43() { assertFile(new File("./examples/timer_flat.abcd").getPath()); }
	@Test public void test44() { assertFile(new File("./examples/timer_shared.abcd").getPath()); }
	@Test public void test45() { assertFile(new File("./examples/uml/uml_pingpongs/pingpong.abcd").getPath()); }
	@Test public void test46() { assertFile(new File("./examples/uml/uml_pingpongs/pingpong_multiple.abcd").getPath()); }
	@Test public void test47() { assertFile(new File("./examples/uml/uml_pingpongs/pingpong_multiple_signed.abcd").getPath()); }
	@Test public void test48() { assertFile(new File("./examples/uml/uml_pingpongs/pingpong_multiple_signed_select.abcd").getPath()); }
	@Test public void test49() { assertFile(new File("./examples/example9-expressions.abcd").getPath()); }
	
	class ABCDFileFilter implements FilenameFilter {
		public boolean accept(File dir, String name) {
			return name.endsWith(".abcd");
		}
	}
	
	public void assertFile(String filename) {
		ABCDSystem sys = null;
		try {
			sys = Compiler.compile(new File(filename));
		} catch (Exception e) {
			System.err.println("testing "+ filename);
			e.printStackTrace();
		}
		assertTrue("testing "+ filename, sys != null);
	}
	
	

}
