package org.cte.ABCD.fiacre.tests;

import static org.junit.Assert.assertEquals;

import obp.fiacre.model.FunctionDecl;
import obp.fiacre.model.Type;
import obp.fiacre.model.TypeDecl;
import obp.fiacre.model.Union;
import obp.fiacre.util.FiacrePrinter;

import org.cte.ABCD.fiacre.FiacreBuilderForABCD;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

public class FiacreBuilderForAbcdTest {
	
	FiacreBuilderForABCD builder;
	
	@Before
	public void init() {
		builder = new FiacreBuilderForABCD();
	}
	
	@Test
	public void testCreateDeferredHandler() {
		Type uT = builder.unionType("evtA", "evtB");
		TypeDecl uTD = builder.typeDecl("t_message", uT);
		Type bT = builder.boolType();
		Type maskT = builder.arrayType(builder.literal(((Union)uT).getConstrCount()), bT);
		TypeDecl maskTD = builder.typeDecl("t_mask", maskT);
		Type ePT = builder.queueType(builder.literal(3), builder.type(uTD));
		TypeDecl ePTD = builder.typeDecl("t_eventPool", ePT);
		FunctionDecl f = builder.createDeferredHandler("t_message", builder.type(ePTD), builder.type(maskTD));
	
		
		
		FiacrePrinter fP = new FiacrePrinter();
		assertEquals(deferredHandleString(), fP.print(f));
	}
	
	@Ignore
	public String deferredHandleString() {
		StringBuilder sb = new StringBuilder();
		sb.append("function processDeferred_t_message (eventPool: t_eventPool, deferMask: t_mask) : t_eventPool is\n");
		sb.append("var \n");
		sb.append("deferred: t_eventPool := {||}, \n");
		sb.append("result: t_eventPool := {||}, \n");
		sb.append("continue: bool := true \n");
		sb.append("begin\n");
		sb.append("while ((not (empty eventPool)) and continue) do\n");
		sb.append("	case (first eventPool) of\n");
		sb.append("	evtA -> if deferMask[0] then\n");
		sb.append("			deferred := (enqueue(deferred, (first eventPool)));\n");
		sb.append("			eventPool := (dequeue eventPool)\n");
		sb.append("		else \n");
		sb.append("			continue := false\n");
		sb.append("		end if\n");
		sb.append("	| evtB -> if deferMask[1] then\n");
		sb.append("			deferred := (enqueue(deferred, (first eventPool)));\n");
		sb.append("			eventPool := (dequeue eventPool)\n");
		sb.append("		else \n");
		sb.append("			continue := false\n");
		sb.append("		end if\n");
		sb.append("	end case\n");
		sb.append("	end while;\n");
		sb.append("if (not (empty eventPool)) then\n");
		sb.append("	result := (enqueue(result, (first eventPool)));\n");
		sb.append("	eventPool := (dequeue eventPool)\n");
		sb.append("end if;\n");
		sb.append("while (not (empty deferred)) do\n");
		sb.append("	result := (enqueue(result, (first deferred)));\n");
		sb.append("	deferred := (dequeue deferred)\n");
		sb.append("	end while;\n");
		sb.append("while (not (empty eventPool)) do\n");
		sb.append("	result := (enqueue(result, (first eventPool)));\n");
		sb.append("	eventPool := (dequeue eventPool)\n");
		sb.append("	end while;\n");
		sb.append("return result\n");
		sb.append("end");
		return sb.toString();
	}
}
