package test.compiled.complexevents;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class ConsumerBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S1 = 1;

	public static final short S0 = 2;

	public static final short S2 = 3;

	private final ReferencedArgument<ConsumerEvents[]> myEventPoolRef;

	public ConsumerBehavior(SymbolsTable symbols, ReferencedArgument<ConsumerEvents[]> myEventPool) {
		super("Consumer", idSeed++, symbols);
		this.myEventPoolRef = myEventPool;
	}

	private final String[] stateNames = new String[] {"s1", "s0", "s2"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtA.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S1;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtB.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S0;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtC.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S0;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtB.class) {
						me.xx = ((ConsumerEvents.ConsumerEvents_evtB)  FiacreQueueUtil.first(myEventPool)).value;
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S2;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtA.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S1;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtC.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S1;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtC.class) {
						me.args = ((ConsumerEvents.ConsumerEvents_evtC)  FiacreQueueUtil.first(myEventPool)).value;
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S0;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtA.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S2;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ConsumerConfiguration me = (ConsumerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == ConsumerEvents.ConsumerEvents_evtB.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S2;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		ConsumerConfiguration me = new ConsumerConfiguration();
		//Initial action code.
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ConsumerConfiguration me = (ConsumerConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ConsumerBehavior.S1: 
			text.append("@s1,");
			break;
		case ConsumerBehavior.S0: 
			text.append("@s0,");
			break;
		case ConsumerBehavior.S2: 
			text.append("@s2,");
			break;
		}
		text.append("\n\t- args=");
		text.append(me.args.toString());
		text.append("\n\t- xx=");
		text.append(Integer.toString(me.xx));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ConsumerConfiguration me = (ConsumerConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ConsumerBehavior.S1: 
			text.append("@s1,");
			break;
		case ConsumerBehavior.S0: 
			text.append("@s0,");
			break;
		case ConsumerBehavior.S2: 
			text.append("@s2,");
			break;
		}
		text.append(" args=");
		text.append(me.args.toString());
		text.append(" xx=");
		text.append(Integer.toString(me.xx));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		ConsumerConfiguration me = new ConsumerConfiguration();
		me.state = boost.readShort();
		me.args = boost.readObject(Targs1.class);
		me.xx = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		ConsumerConfiguration me = (ConsumerConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeObject(me.args);
		boost.writeInt(me.xx);
	}

}

