package test.compiled.complexevents;

import org.xid.basics.serializer.BoostObject;
import org.xid.basics.serializer.Boost;

public abstract class ConsumerEvents implements BoostObject {

	public static class ConsumerEvents_evtA extends ConsumerEvents {

		public ConsumerEvents_evtA() {
		}

		public ConsumerEvents_evtA(ConsumerEvents_evtA other) {
		}

		public ConsumerEvents_evtA(Boost boost) {
			boost.register(this);
		}

		public void writeToBoost(Boost boost) {
		}

		@Override
		public boolean equals(Object object) {
			return object != null && object.getClass() == ConsumerEvents_evtA.class;
		}

		@Override
		public int hashCode() {
			int total = 960558;
			return total;
		}

		public String toString() {
			StringBuilder text = new StringBuilder();
			text.append("{ConsumerEvents_evtA");
			text.append("}");
			return text.toString();
		}

	}

	public static class ConsumerEvents_evtB extends ConsumerEvents {

		public int value;

		public ConsumerEvents_evtB() {
			this.value = 0;
		}

		public ConsumerEvents_evtB(int value) {
			this.value = value;
		}

		public ConsumerEvents_evtB(ConsumerEvents_evtB other) {
			this.value = other.value;
		}

		public ConsumerEvents_evtB(Boost boost) {
			boost.register(this);
			this.value = boost.readInt();
		}

		public void writeToBoost(Boost boost) {
			boost.writeInt(value);
		}

		@Override
		public boolean equals(Object object) {
			if (object instanceof ConsumerEvents_evtB) {
				ConsumerEvents_evtB other = (ConsumerEvents_evtB) object;
				if (value != other.value) return false;
				return true;
			}
			return false;
		}

		@Override
		public int hashCode() {
			int total = 385001;
			total = total * 37 + value;
			return total;
		}

		public String toString() {
			StringBuilder text = new StringBuilder();
			text.append("{ConsumerEvents_evtB");
			text.append("@");
			text.append(Integer.toString(value));
			text.append("}");
			return text.toString();
		}

	}

	public static class ConsumerEvents_evtC extends ConsumerEvents {

		public Targs1 value;

		public ConsumerEvents_evtC() {
			this.value = new Targs1();
		}

		public ConsumerEvents_evtC(Targs1 value) {
			this.value = value;
		}

		public ConsumerEvents_evtC(ConsumerEvents_evtC other) {
			this.value = new Targs1(other.value);
		}

		public ConsumerEvents_evtC(Boost boost) {
			boost.register(this);
			this.value = boost.readObject(Targs1.class);
		}

		public void writeToBoost(Boost boost) {
			boost.writeObject(value);
		}

		@Override
		public boolean equals(Object object) {
			if (object instanceof ConsumerEvents_evtC) {
				ConsumerEvents_evtC other = (ConsumerEvents_evtC) object;
				if (!value.equals(other.value)) return false;
				return true;
			}
			return false;
		}

		@Override
		public int hashCode() {
			int total = 744852;
			total = total * 37 + value.hashCode();
			return total;
		}

		public String toString() {
			StringBuilder text = new StringBuilder();
			text.append("{ConsumerEvents_evtC");
			text.append("@");
			text.append(value.toString());
			text.append("}");
			return text.toString();
		}

	}

	public static ConsumerEvents copy(ConsumerEvents other) {
		if (other == null) {
			return null;
		}
		else if ( other.getClass() == ConsumerEvents_evtA.class ) {
			return new ConsumerEvents_evtA((ConsumerEvents_evtA) other);
		}
		else if ( other.getClass() == ConsumerEvents_evtB.class ) {
			return new ConsumerEvents_evtB((ConsumerEvents_evtB) other);
		}
		else if ( other.getClass() == ConsumerEvents_evtC.class ) {
			return new ConsumerEvents_evtC((ConsumerEvents_evtC) other);
		}
		throw new IllegalArgumentException("Unknown constructor for 'ConsumerEvents'.");
	}

}

