package test.compiled.complexevents;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public MainBehavior(SymbolsTable symbols) {
		super("main", idSeed++, symbols);
	}

	public ReferencedArgument<ConsumerEvents[]> getToTheConsumerRef() {
return 		new ReferencedArgument<ConsumerEvents[]>(id) {
			@Override
			public ConsumerEvents[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.toTheConsumer;
			}

			@Override
			public void set(Configuration configuration, ConsumerEvents[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.toTheConsumer = value;
			}

			@Override
			public  Class<ConsumerEvents[]> getArgumentType() {
				return ConsumerEvents[].class;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		MainConfiguration me = new MainConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- toTheConsumer=");
		text.append(Arrays.deepToString(me.toTheConsumer));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" toTheConsumer=");
		text.append(Arrays.deepToString(me.toTheConsumer));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		MainConfiguration me = new MainConfiguration();
		me.toTheConsumer = new ConsumerEvents[1];
		me.toTheConsumer = new ConsumerEvents[boost.readInt()];
		for (int i=0; i<me.toTheConsumer.length; i++) {
			me.toTheConsumer[i] = boost.readObject(ConsumerEvents.class);
		}
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		MainConfiguration me = (MainConfiguration) processConfiguration;
		boost.writeInt(me.toTheConsumer.length);
		for (int i=0; i<me.toTheConsumer.length; i++) {
			boost.writeObject(me.toTheConsumer[i]);
		}
	}

}

