package test.compiled.complexevents;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class ProducerBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S0 = 1;

	private final ReferencedArgument<ConsumerEvents[]> itsConsumerRef;

	public ProducerBehavior(SymbolsTable symbols, ReferencedArgument<ConsumerEvents[]> itsConsumer) {
		super("Producer", idSeed++, symbols);
		this.itsConsumerRef = itsConsumer;
	}

	private final String[] stateNames = new String[] {"s0"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] itsConsumer = itsConsumerRef.get(configuration);
			modifiedBehaviors[itsConsumerRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] itsConsumer = itsConsumerRef.get(configuration);
			try {
				if ( !( (itsConsumer.length >= 1 )) == true) {
					itsConsumer = FiacreQueueUtil.enqueue(id, itsConsumer,new ConsumerEvents.ConsumerEvents_evtA(), actions);
				} else {
					if (true) { return false; }
				}
				me.state = S0;
				if (true) return true;
			} finally {
				itsConsumerRef.set(configuration, itsConsumer);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] itsConsumer = itsConsumerRef.get(configuration);
			modifiedBehaviors[itsConsumerRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] itsConsumer = itsConsumerRef.get(configuration);
			try {
				me.x = ((me.x) + (1)) % (3);
				if ( !( (itsConsumer.length >= 1 )) == true) {
					itsConsumer = FiacreQueueUtil.enqueue(id, itsConsumer,new ConsumerEvents.ConsumerEvents_evtB(me.x), actions);
				} else {
					if (true) { return false; }
				}
				me.state = S0;
				if (true) return true;
			} finally {
				itsConsumerRef.set(configuration, itsConsumer);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] itsConsumer = itsConsumerRef.get(configuration);
			modifiedBehaviors[itsConsumerRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ProducerConfiguration me = (ProducerConfiguration) configuration.behaviorConfigurations[id];
			ConsumerEvents[] itsConsumer = itsConsumerRef.get(configuration);
			try {
				me.b =  !(me.b);
				if ( !( (itsConsumer.length >= 1 )) == true) {
					itsConsumer = FiacreQueueUtil.enqueue(id, itsConsumer,new ConsumerEvents.ConsumerEvents_evtC(new Targs1((me.x) + (2), !(me.b),new int[] {(me.x) * (2), (me.x) * (3), (me.x) * (4)})), actions);
				} else {
					if (true) { return false; }
				}
				me.state = S0;
				if (true) return true;
			} finally {
				itsConsumerRef.set(configuration, itsConsumer);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		ProducerConfiguration me = new ProducerConfiguration();
		//Initial action code.
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ProducerConfiguration me = (ProducerConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ProducerBehavior.S0: 
			text.append("@s0,");
			break;
		}
		text.append("\n\t- x=");
		text.append(Integer.toString(me.x));
		text.append("\n\t- b=");
		text.append(Boolean.toString(me.b));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ProducerConfiguration me = (ProducerConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ProducerBehavior.S0: 
			text.append("@s0,");
			break;
		}
		text.append(" x=");
		text.append(Integer.toString(me.x));
		text.append(" b=");
		text.append(Boolean.toString(me.b));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		ProducerConfiguration me = new ProducerConfiguration();
		me.state = boost.readShort();
		me.x = boost.readInt();
		me.b = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		ProducerConfiguration me = (ProducerConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.x);
		boost.writeBoolean(me.b);
	}

}

