package test.compiled.complexevents;

import org.xid.basics.serializer.BoostObject;
import org.xid.basics.serializer.Boost;
import java.util.Arrays;

public class Targs1 implements BoostObject {

	public int x;

	public boolean y;

	public int[] z;

	public Targs1() {
		this.x = 0;
		this.y = false;
		this.z = new int[]{0,0,0};
	}

	public Targs1(int x, boolean y, int[] z) {
		this.x = x;
		this.y = y;
		this.z = z;
	}

	public Targs1(Targs1 other) {
		this.x = other.x;
		this.y = other.y;
		this.z = new int[3];
		for (int i=0; i<other.z.length; i++) {
			this.z[i] = other.z[i];
		}
	}

	public Targs1(Boost boost) {
		boost.register(this);
		this.x = boost.readInt();
		this.y = boost.readBoolean();
		this.z = new int[3];
		for (int i=0; i<this.z.length; i++) {
			this.z[i] = boost.readInt();
		}
	}

	public void writeToBoost(Boost boost) {
		boost.writeInt(x);
		boost.writeBoolean(y);
		for (int i=0; i<z.length; i++) {
			boost.writeInt(z[i]);
		}
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof Targs1) {
			Targs1 other = (Targs1) object;
			if (x != other.x) return false;
			if (y != other.y) return false;
			if (!Arrays.equals(z, other.z)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + x;
		total = total * 37 + (y? 1 : 0);
		total = total * 37 + Arrays.hashCode(z);
		return total;
	}

	public String toString() {
		StringBuilder text = new StringBuilder();
		text.append("{");
		text.append("x=");
		text.append(Integer.toString(x));
		text.append(",y=");
		text.append(Boolean.toString(y));
		text.append(",z=");
		text.append(Arrays.toString(z));
		text.append("}");
		return text.toString();
	}

}

