package test.compiled.example11_par;

import org.xid.basics.serializer.BoostObject;
import org.xid.basics.serializer.Boost;
import java.util.Arrays;

public class Mrec implements BoostObject {

	public int x;

	public int y;

	public int[] l;

	public Mrec() {
		this.x = 0;
		this.y = 0;
		this.l = new int[]{0,0,0,0,0,0,0};
	}

	public Mrec(int x, int y, int[] l) {
		this.x = x;
		this.y = y;
		this.l = l;
	}

	public Mrec(Mrec other) {
		this.x = other.x;
		this.y = other.y;
		this.l = new int[7];
		for (int i=0; i<other.l.length; i++) {
			this.l[i] = other.l[i];
		}
	}

	public Mrec(Boost boost) {
		boost.register(this);
		this.x = boost.readInt();
		this.y = boost.readInt();
		this.l = new int[7];
		for (int i=0; i<this.l.length; i++) {
			this.l[i] = boost.readInt();
		}
	}

	public void writeToBoost(Boost boost) {
		boost.writeInt(x);
		boost.writeInt(y);
		for (int i=0; i<l.length; i++) {
			boost.writeInt(l[i]);
		}
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof Mrec) {
			Mrec other = (Mrec) object;
			if (x != other.x) return false;
			if (y != other.y) return false;
			if (!Arrays.equals(l, other.l)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + x;
		total = total * 37 + y;
		total = total * 37 + Arrays.hashCode(l);
		return total;
	}

	public String toString() {
		StringBuilder text = new StringBuilder();
		text.append("{");
		text.append("x=");
		text.append(Integer.toString(x));
		text.append(",y=");
		text.append(Integer.toString(y));
		text.append(",l=");
		text.append(Arrays.toString(l));
		text.append("}");
		return text.toString();
	}

}

