package test.compiled.example16_mutex;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel sharedMlock0 = new BroadcastChannel(name+":sharedMlock0", symbols, 1, 1);
		BroadcastChannel sharedMunlock0 = new BroadcastChannel(name+":sharedMunlock0", symbols, 1, 1);
		BroadcastChannel sharedMlock1 = new BroadcastChannel(name+":sharedMlock1", symbols, 1, 1);
		BroadcastChannel sharedMunlock1 = new BroadcastChannel(name+":sharedMunlock1", symbols, 1, 1);
		BroadcastChannel sharedNlock0 = new BroadcastChannel(name+":sharedNlock0", symbols, 1, 1);
		BroadcastChannel sharedNunlock0 = new BroadcastChannel(name+":sharedNunlock0", symbols, 1, 1);
		BroadcastChannel sharedNlock1 = new BroadcastChannel(name+":sharedNlock1", symbols, 1, 1);
		BroadcastChannel sharedNunlock1 = new BroadcastChannel(name+":sharedNunlock1", symbols, 1, 1);
		BroadcastChannel sharedNlock2 = new BroadcastChannel(name+":sharedNlock2", symbols, 1, 1);
		BroadcastChannel sharedNunlock2 = new BroadcastChannel(name+":sharedNunlock2", symbols, 1, 1);
		channels = new Channel[] { sharedMlock0, sharedMunlock0, sharedMlock1, sharedMunlock1, sharedNlock0, sharedNunlock0, sharedNlock1, sharedNunlock1, sharedNlock2, sharedNunlock2,  };
		
		components = new Component[] {
				new PBehavior(symbols, sharedMlock0, sharedMunlock0),
				new PBehavior(symbols, sharedMlock1, sharedMunlock1),
				new PBehavior(symbols, sharedNlock0, sharedNunlock0),
				new PBehavior(symbols, sharedNlock1, sharedNunlock1),
				new PBehavior(symbols, sharedNlock2, sharedNunlock2),
				new Mutex_2Behavior(symbols, sharedMlock0, sharedMunlock0, sharedMlock1, sharedMunlock1),
				new Mutex_3Behavior(symbols, sharedNlock0, sharedNunlock0, sharedNlock1, sharedNunlock1, sharedNlock2, sharedNunlock2)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

