package test.compiled.example1_rw;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		MainBehavior me = new MainBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		BroadcastChannel w_evt = new BroadcastChannel(me.name+":w_evt", symbols, 1, 1);
		BroadcastChannel r_evt = new BroadcastChannel(me.name+":r_evt", symbols, 1, 1);
		channels = new Channel[] { w_evt, r_evt,  };
		
		components = new Component[] {
				me,
				new ProcWBehavior(symbols, w_evt, me.getDataRef()),
				new ProcRBehavior(symbols, r_evt, me.getDataRef()),
				new SchedBehavior(symbols, r_evt, w_evt)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

