package test.compiled.example2_commsync;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel wr_evt = new BroadcastChannel(name+":wr_evt", symbols, 1, 1);
		channels = new Channel[] { wr_evt,  };
		
		components = new Component[] {
				new ProcWBehavior(symbols, wr_evt),
				new ProcRBehavior(symbols, wr_evt)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

