package test.compiled.example3_async_2chan_b;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel f1_put = new BroadcastChannel(name+":f1_put", symbols, 1, 1);
		BroadcastChannel f1_get = new BroadcastChannel(name+":f1_get", symbols, 1, 1);
		BroadcastChannel f2_put = new BroadcastChannel(name+":f2_put", symbols, 1, 1);
		BroadcastChannel f2_get = new BroadcastChannel(name+":f2_get", symbols, 1, 1);
		channels = new Channel[] { f1_put, f1_get, f2_put, f2_get,  };
		
		components = new Component[] {
				new Fifo2blockBehavior(symbols, f1_put, f1_get),
				new Fifo2blockBehavior(symbols, f2_put, f2_get),
				new ProcWBehavior(symbols, f1_put),
				new ProcRBehavior(symbols, f1_get),
				new ProcWBehavior(symbols, f2_put),
				new ProcRBehavior(symbols, f2_get)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

