package test.compiled.example3_async_2chan_bnb;

import org.xid.basics.serializer.BoostObject;
import org.xid.basics.serializer.Boost;

public class FifoGetProtocol implements BoostObject {

	public int value;

	public boolean valid;

	public FifoGetProtocol() {
		this.value = 0;
		this.valid = false;
	}

	public FifoGetProtocol(int value, boolean valid) {
		this.value = value;
		this.valid = valid;
	}

	public FifoGetProtocol(FifoGetProtocol other) {
		this.value = other.value;
		this.valid = other.valid;
	}

	public FifoGetProtocol(Boost boost) {
		boost.register(this);
		this.value = boost.readInt();
		this.valid = boost.readBoolean();
	}

	public void writeToBoost(Boost boost) {
		boost.writeInt(value);
		boost.writeBoolean(valid);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof FifoGetProtocol) {
			FifoGetProtocol other = (FifoGetProtocol) object;
			if (value != other.value) return false;
			if (valid != other.valid) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + value;
		total = total * 37 + (valid? 1 : 0);
		return total;
	}

	public String toString() {
		StringBuilder text = new StringBuilder();
		text.append("{");
		text.append("value=");
		text.append(Integer.toString(value));
		text.append(",valid=");
		text.append(Boolean.toString(valid));
		text.append("}");
		return text.toString();
	}

}

