package test.compiled.example3_async_noblock;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class Fifo2noblockConfiguration extends BehaviorConfiguration {

	public short state;

	public int[] fifo;

	//Create initial configuration
	public Fifo2noblockConfiguration() {
		this.fifo = new int[] {};
	}

	//Create configuration as a copy
	public Fifo2noblockConfiguration(Fifo2noblockConfiguration other) {
		this.state = other.state;
		this.fifo = new int[other.fifo.length];
		for (int i=0; i<other.fifo.length; i++) {
			this.fifo[i] = other.fifo[i];
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new Fifo2noblockConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof Fifo2noblockConfiguration) {
			Fifo2noblockConfiguration other = (Fifo2noblockConfiguration) object;
			if (state != other.state) return false;
			if (!Arrays.equals(fifo, other.fifo)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + Arrays.hashCode(fifo);
		return total;
	}

}

