package test.compiled.example3_async_sync;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class Fifo4blockConfiguration extends BehaviorConfiguration {

	public short state;

	public int[] fifo;

	//Create initial configuration
	public Fifo4blockConfiguration() {
		this.fifo = new int[] {};
	}

	//Create configuration as a copy
	public Fifo4blockConfiguration(Fifo4blockConfiguration other) {
		this.state = other.state;
		this.fifo = new int[other.fifo.length];
		for (int i=0; i<other.fifo.length; i++) {
			this.fifo[i] = other.fifo[i];
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new Fifo4blockConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof Fifo4blockConfiguration) {
			Fifo4blockConfiguration other = (Fifo4blockConfiguration) object;
			if (state != other.state) return false;
			if (!Arrays.equals(fifo, other.fifo)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + Arrays.hashCode(fifo);
		return total;
	}

}

