package test.compiled.example3_async_sync_noblock;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel fifo_put = new BroadcastChannel(name+":fifo_put", symbols, 1, 1);
		BroadcastChannel fifo_get = new BroadcastChannel(name+":fifo_get", symbols, 1, 1);
		BroadcastChannel nofifo = new BroadcastChannel(name+":nofifo", symbols, 1, 1);
		channels = new Channel[] { fifo_put, fifo_get, nofifo,  };
		
		components = new Component[] {
				new Fifo4noblockBehavior(symbols, fifo_put, fifo_get),
				new ProcWBehavior(symbols, fifo_put),
				new ProcR0Behavior(symbols, fifo_get),
				new ProcWBehavior(symbols, nofifo),
				new ProcRBehavior(symbols, nofifo)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

