package test.compiled.example3_async_sync_noblock;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class ProcRBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Start = 1;

	private final BroadcastChannel f_get;

	public ProcRBehavior(SymbolsTable symbols, BroadcastChannel f_get) {
		super("ProcR", idSeed++, symbols);
		this.f_get = f_get;
	}

	private final String[] stateNames = new String[] {"Start"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return f_get.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			ProcRConfiguration me = (ProcRConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final ProcRConfiguration me = (ProcRConfiguration) configuration.behaviorConfigurations[id];
			f_get.input(id, actions);
			me.val = f_get.value(int.class,0);
			if ( f_get.clockId != -1 ) {
				DBM.set(configuration.dbm, f_get.clockId, 0);
			}
			me.state = Start;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		ProcRConfiguration me = new ProcRConfiguration();
		//Initial action code.
		me.state = Start;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ProcRConfiguration me = (ProcRConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ProcRBehavior.Start: 
			text.append("@Start,");
			break;
		}
		text.append("\n\t- val=");
		text.append(Integer.toString(me.val));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		ProcRConfiguration me = (ProcRConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case ProcRBehavior.Start: 
			text.append("@Start,");
			break;
		}
		text.append(" val=");
		text.append(Integer.toString(me.val));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		ProcRConfiguration me = new ProcRConfiguration();
		me.state = boost.readShort();
		me.val = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		ProcRConfiguration me = (ProcRConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.val);
	}

}

