package test.compiled.example3_commasync;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel fifo_wr_put = new BroadcastChannel(name+":fifo_wr_put", symbols, 1, 1);
		BroadcastChannel fifo_wr_get = new BroadcastChannel(name+":fifo_wr_get", symbols, 1, 1);
		channels = new Channel[] { fifo_wr_put, fifo_wr_get,  };
		
		components = new Component[] {
				new Fifo3blockBehavior(symbols, fifo_wr_put, fifo_wr_get),
				new ProcWBehavior(symbols, fifo_wr_put),
				new ProcRBehavior(symbols, fifo_wr_get)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

