package test.compiled.example4_comput;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class CmdBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Start = 1;

	public static final short StartTimer = 2;

	public static final short Wait = 3;

	public static final short StopTimer = 4;

	public static final short TimeOut = 5;

	private final BroadcastChannel req;

	private final BroadcastChannel done;

	private final BroadcastChannel start1;

	private final BroadcastChannel stop1;

	private final BroadcastChannel timeout1;

	public CmdBehavior(SymbolsTable symbols, BroadcastChannel req, BroadcastChannel done, BroadcastChannel start1, BroadcastChannel stop1, BroadcastChannel timeout1) {
		super("cmd", idSeed++, symbols);
		this.req = req;
		this.done = done;
		this.start1 = start1;
		this.stop1 = stop1;
		this.timeout1 = timeout1;
	}

	private final String[] stateNames = new String[] {"Start", "StartTimer", "Wait", "StopTimer", "TimeOut"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return req.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			req.output(id, actions);
			me.state = StartTimer;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return start1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != StartTimer) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			start1.output(id, actions, 1);
			me.state = Wait;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return done.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Wait) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			done.input(id, actions);
			if ( done.clockId != -1 ) {
				DBM.set(configuration.dbm, done.clockId, 0);
			}
			me.state = StopTimer;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return timeout1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Wait) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			timeout1.input(id, actions);
			if ( timeout1.clockId != -1 ) {
				DBM.set(configuration.dbm, timeout1.clockId, 0);
			}
			me.state = TimeOut;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return stop1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != StopTimer) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			stop1.output(id, actions);
			me.state = Start;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != TimeOut) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final CmdConfiguration me = (CmdConfiguration) configuration.behaviorConfigurations[id];
			me.state = TimeOut;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		CmdConfiguration me = new CmdConfiguration();
		//Initial action code.
		me.state = Start;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CmdConfiguration me = (CmdConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case CmdBehavior.Start: 
			text.append("@Start,");
			break;
		case CmdBehavior.StartTimer: 
			text.append("@StartTimer,");
			break;
		case CmdBehavior.Wait: 
			text.append("@Wait,");
			break;
		case CmdBehavior.StopTimer: 
			text.append("@StopTimer,");
			break;
		case CmdBehavior.TimeOut: 
			text.append("@TimeOut,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		CmdConfiguration me = (CmdConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case CmdBehavior.Start: 
			text.append("@Start,");
			break;
		case CmdBehavior.StartTimer: 
			text.append("@StartTimer,");
			break;
		case CmdBehavior.Wait: 
			text.append("@Wait,");
			break;
		case CmdBehavior.StopTimer: 
			text.append("@StopTimer,");
			break;
		case CmdBehavior.TimeOut: 
			text.append("@TimeOut,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		CmdConfiguration me = new CmdConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		CmdConfiguration me = (CmdConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

