package test.compiled.example4_comput;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel req_evt = new BroadcastChannel(name+":req_evt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel done_evt = new BroadcastChannel(name+":done_evt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timStart0 = new BroadcastChannel(name+":timStart0", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timStop1 = new BroadcastChannel(name+":timStop1", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timTimeout2 = new BroadcastChannel(name+":timTimeout2", symbols, 1, 1, 0, false, 0, false);
		channels = new Channel[] { req_evt, done_evt, timStart0, timStop1, timTimeout2,  };
		
		components = new Component[] {
				new CmdBehavior(symbols, req_evt, done_evt, timStart0, timStop1, timTimeout2),
				new ComputeBehavior(symbols, req_evt, done_evt),
				new Tim_1_1_1Behavior(symbols, timStart0, timStop1, timTimeout2)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

