package test.compiled.example5_prodcons_nomulti;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class FifoConfiguration extends BehaviorConfiguration {

	public short state;

	public int data;

	public int[] fifo;

	//Create initial configuration
	public FifoConfiguration() {
		this.data = 0;
		this.fifo = new int[]{};
	}

	//Create configuration as a copy
	public FifoConfiguration(FifoConfiguration other) {
		this.state = other.state;
		this.data = other.data;
		this.fifo = new int[other.fifo.length];
		for (int i=0; i<other.fifo.length; i++) {
			this.fifo[i] = other.fifo[i];
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new FifoConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof FifoConfiguration) {
			FifoConfiguration other = (FifoConfiguration) object;
			if (state != other.state) return false;
			if (data != other.data) return false;
			if (!Arrays.equals(fifo, other.fifo)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + data;
		total = total * 37 + Arrays.hashCode(fifo);
		return total;
	}

}

