package test.compiled.example5_prodcons_nomulti;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel prod_sEvt = new BroadcastChannel(name+":prod_sEvt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel prod_eEvt = new BroadcastChannel(name+":prod_eEvt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel fifo_sEvt = new BroadcastChannel(name+":fifo_sEvt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel fifo_eEvt = new BroadcastChannel(name+":fifo_eEvt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel cons_sEvt = new BroadcastChannel(name+":cons_sEvt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel cons_eEvt = new BroadcastChannel(name+":cons_eEvt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel mmi_sEvt = new BroadcastChannel(name+":mmi_sEvt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel mmi_eEvt = new BroadcastChannel(name+":mmi_eEvt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel put_evt = new BroadcastChannel(name+":put_evt", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel get_evt = new BroadcastChannel(name+":get_evt", symbols, 1, 1, 0, false, 0, false);
		channels = new Channel[] { prod_sEvt, prod_eEvt, fifo_sEvt, fifo_eEvt, cons_sEvt, cons_eEvt, mmi_sEvt, mmi_eEvt, put_evt, get_evt,  };
		
		components = new Component[] {
				new OsProcessBehavior(symbols, mmi_sEvt, mmi_eEvt),
				new MmiBehavior(symbols, mmi_sEvt, mmi_eEvt, prod_sEvt, prod_eEvt, cons_sEvt, cons_eEvt, fifo_sEvt, fifo_eEvt),
				new ProducerBehavior(symbols, prod_sEvt, prod_eEvt, put_evt),
				new ConsumerBehavior(symbols, cons_sEvt, cons_eEvt, get_evt),
				new FifoBehavior(symbols, fifo_sEvt, fifo_eEvt, put_evt, get_evt)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

