package test.compiled.example5_prodcons_nomulti;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class MmiBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Start = 1;

	public static final short S1 = 2;

	public static final short Stop = 3;

	public static final short S2 = 4;

	public static final short S3 = 5;

	public static final short Mwait = 6;

	public static final short W1 = 7;

	public static final short W2 = 8;

	public static final short W3 = 9;

	private final BroadcastChannel sEvt;

	private final BroadcastChannel eEvt;

	private final BroadcastChannel p_sEvt;

	private final BroadcastChannel p_eEvt;

	private final BroadcastChannel c_sEvt;

	private final BroadcastChannel c_eEvt;

	private final BroadcastChannel f_sEvt;

	private final BroadcastChannel f_eEvt;

	public MmiBehavior(SymbolsTable symbols, BroadcastChannel sEvt, BroadcastChannel eEvt, BroadcastChannel p_sEvt, BroadcastChannel p_eEvt, BroadcastChannel c_sEvt, BroadcastChannel c_eEvt, BroadcastChannel f_sEvt, BroadcastChannel f_eEvt) {
		super("mmi", idSeed++, symbols);
		this.sEvt = sEvt;
		this.eEvt = eEvt;
		this.p_sEvt = p_sEvt;
		this.p_eEvt = p_eEvt;
		this.c_sEvt = c_sEvt;
		this.c_eEvt = c_eEvt;
		this.f_sEvt = f_sEvt;
		this.f_eEvt = f_eEvt;
	}

	private final String[] stateNames = new String[] {"start", "s1", "stop", "s2", "s3", "mwait", "w1", "w2", "w3"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return sEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			sEvt.input(id, actions);
			if ( sEvt.clockId != -1 ) {
				DBM.set(configuration.dbm, sEvt.clockId, 0);
			}
			me.state = S1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return eEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Start) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			eEvt.input(id, actions);
			if ( eEvt.clockId != -1 ) {
				DBM.set(configuration.dbm, eEvt.clockId, 0);
			}
			me.state = Stop;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return p_sEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			p_sEvt.output(id, actions);
			me.state = S2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return c_sEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			c_sEvt.output(id, actions);
			me.state = S3;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return f_sEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S3) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			f_sEvt.output(id, actions);
			me.state = Mwait;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return eEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Mwait) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			eEvt.input(id, actions);
			if ( eEvt.clockId != -1 ) {
				DBM.set(configuration.dbm, eEvt.clockId, 0);
			}
			me.state = W1;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return p_eEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != W1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			p_eEvt.output(id, actions);
			me.state = W2;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return c_eEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != W2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			c_eEvt.output(id, actions);
			me.state = W3;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition8 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return f_eEvt.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != W3) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			f_eEvt.output(id, actions);
			me.state = Stop;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition9 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Stop) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final MmiConfiguration me = (MmiConfiguration) configuration.behaviorConfigurations[id];
			me.state = Stop;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
		transition8,
		transition9,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		MmiConfiguration me = new MmiConfiguration();
		//Initial action code.
		me.state = Start;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MmiConfiguration me = (MmiConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case MmiBehavior.Start: 
			text.append("@start,");
			break;
		case MmiBehavior.S1: 
			text.append("@s1,");
			break;
		case MmiBehavior.Stop: 
			text.append("@stop,");
			break;
		case MmiBehavior.S2: 
			text.append("@s2,");
			break;
		case MmiBehavior.S3: 
			text.append("@s3,");
			break;
		case MmiBehavior.Mwait: 
			text.append("@mwait,");
			break;
		case MmiBehavior.W1: 
			text.append("@w1,");
			break;
		case MmiBehavior.W2: 
			text.append("@w2,");
			break;
		case MmiBehavior.W3: 
			text.append("@w3,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MmiConfiguration me = (MmiConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case MmiBehavior.Start: 
			text.append("@start,");
			break;
		case MmiBehavior.S1: 
			text.append("@s1,");
			break;
		case MmiBehavior.Stop: 
			text.append("@stop,");
			break;
		case MmiBehavior.S2: 
			text.append("@s2,");
			break;
		case MmiBehavior.S3: 
			text.append("@s3,");
			break;
		case MmiBehavior.Mwait: 
			text.append("@mwait,");
			break;
		case MmiBehavior.W1: 
			text.append("@w1,");
			break;
		case MmiBehavior.W2: 
			text.append("@w2,");
			break;
		case MmiBehavior.W3: 
			text.append("@w3,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		MmiConfiguration me = new MmiConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		MmiConfiguration me = (MmiConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

