package test.compiled.example6_stack;

import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class ClientPushConfiguration extends BehaviorConfiguration {

	public short state;

	public int data;

	public boolean ackv;

	//Create initial configuration
	public ClientPushConfiguration() {
		this.data = 0;
		this.ackv = false;
	}

	//Create configuration as a copy
	public ClientPushConfiguration(ClientPushConfiguration other) {
		this.state = other.state;
		this.data = other.data;
		this.ackv = other.ackv;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new ClientPushConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof ClientPushConfiguration) {
			ClientPushConfiguration other = (ClientPushConfiguration) object;
			if (state != other.state) return false;
			if (data != other.data) return false;
			if (ackv != other.ackv) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + data;
		total = total * 37 + (ackv? 1 : 0);
		return total;
	}

}

