package test.compiled.example6_stack;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel stack_start = new BroadcastChannel(name+":stack_start", symbols, 1, 1);
		BroadcastChannel pop_evt = new BroadcastChannel(name+":pop_evt", symbols, 1, 1);
		BroadcastChannel push_evt = new BroadcastChannel(name+":push_evt", symbols, 1, 1);
		BroadcastChannel pop_ack = new BroadcastChannel(name+":pop_ack", symbols, 1, 1);
		BroadcastChannel push_ack = new BroadcastChannel(name+":push_ack", symbols, 1, 1);
		channels = new Channel[] { stack_start, pop_evt, push_evt, pop_ack, push_ack,  };
		
		components = new Component[] {
				new ClientPushBehavior(symbols, stack_start, push_evt, push_ack),
				new ClientPopBehavior(symbols, pop_evt, pop_ack),
				new StackBehavior(symbols, stack_start, pop_evt, push_evt, push_ack, pop_ack)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

