package test.compiled.example6_stack;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class StackConfiguration extends BehaviorConfiguration {

	public short state;

	public int[] stack;

	public int top_index;

	public boolean ack;

	public int data;

	//Create initial configuration
	public StackConfiguration() {
		this.stack = new int[]{0,0};
		this.top_index = 0;
		this.ack = false;
		this.data = 0;
	}

	//Create configuration as a copy
	public StackConfiguration(StackConfiguration other) {
		this.state = other.state;
		this.stack = new int[Example6_stackRoot.N];
		for (int i=0; i<other.stack.length; i++) {
			this.stack[i] = other.stack[i];
		}
		this.top_index = other.top_index;
		this.ack = other.ack;
		this.data = other.data;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new StackConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof StackConfiguration) {
			StackConfiguration other = (StackConfiguration) object;
			if (state != other.state) return false;
			if (!Arrays.equals(stack, other.stack)) return false;
			if (top_index != other.top_index) return false;
			if (ack != other.ack) return false;
			if (data != other.data) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + Arrays.hashCode(stack);
		total = total * 37 + top_index;
		total = total * 37 + (ack? 1 : 0);
		total = total * 37 + data;
		return total;
	}

}

