package test.compiled.example7_mutex;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		MainBehavior me = new MainBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		BroadcastChannel semlock0 = new BroadcastChannel(me.name+":Semlock0", symbols, 1, 1);
		BroadcastChannel semunlock0 = new BroadcastChannel(me.name+":Semunlock0", symbols, 1, 1);
		BroadcastChannel semlock1 = new BroadcastChannel(me.name+":Semlock1", symbols, 1, 1);
		BroadcastChannel semunlock1 = new BroadcastChannel(me.name+":Semunlock1", symbols, 1, 1);
		channels = new Channel[] { semlock0, semunlock0, semlock1, semunlock1,  };
		
		components = new Component[] {
				me,
				new ProcWBehavior(symbols, semlock0, semunlock0, me.getDataRef()),
				new ProcRBehavior(symbols, semlock1, semunlock1, me.getDataRef()),
				new Mutex_2Behavior(symbols, semlock0, semunlock0, semlock1, semunlock1)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

