package test.compiled.example7_mutex;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class Mutex_2Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Dispatch = 1;

	private final BroadcastChannel lock0;

	private final BroadcastChannel unlock0;

	private final BroadcastChannel lock1;

	private final BroadcastChannel unlock1;

	public Mutex_2Behavior(SymbolsTable symbols, BroadcastChannel lock0, BroadcastChannel unlock0, BroadcastChannel lock1, BroadcastChannel unlock1) {
		super("mutex_2", idSeed++, symbols);
		this.lock0 = lock0;
		this.unlock0 = unlock0;
		this.lock1 = lock1;
		this.unlock1 = unlock1;
	}

	private final String[] stateNames = new String[] {"dispatch"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return lock0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			if ( ( !(me.locked)) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			lock0.input(id, actions);
			if ( lock0.clockId != -1 ) {
				DBM.set(configuration.dbm, lock0.clockId, 0);
			}
			me.locked = true;
			me.id_ = 1;
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			if ( ( !( !(me.locked))) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return unlock0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			unlock0.input(id, actions);
			if ( unlock0.clockId != -1 ) {
				DBM.set(configuration.dbm, unlock0.clockId, 0);
			}
			if (me.id_ == 1) {
				me.locked = false;
				me.id_ = 0;
			}
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return lock1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			if ( ( !(me.locked)) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			lock1.input(id, actions);
			if ( lock1.clockId != -1 ) {
				DBM.set(configuration.dbm, lock1.clockId, 0);
			}
			me.locked = true;
			me.id_ = 2;
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			if ( ( !( !(me.locked))) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return unlock1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Mutex_2Configuration me = (Mutex_2Configuration) configuration.behaviorConfigurations[id];
			unlock1.input(id, actions);
			if ( unlock1.clockId != -1 ) {
				DBM.set(configuration.dbm, unlock1.clockId, 0);
			}
			if (me.id_ == 2) {
				me.locked = false;
				me.id_ = 0;
			}
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Mutex_2Configuration me = new Mutex_2Configuration();
		//Initial action code.
		me.state = Dispatch;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Mutex_2Configuration me = (Mutex_2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Mutex_2Behavior.Dispatch: 
			text.append("@dispatch,");
			break;
		}
		text.append("\n\t- locked=");
		text.append(Boolean.toString(me.locked));
		text.append("\n\t- id=");
		text.append(Integer.toString(me.id_));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Mutex_2Configuration me = (Mutex_2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Mutex_2Behavior.Dispatch: 
			text.append("@dispatch,");
			break;
		}
		text.append(" locked=");
		text.append(Boolean.toString(me.locked));
		text.append(" id=");
		text.append(Integer.toString(me.id_));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Mutex_2Configuration me = new Mutex_2Configuration();
		me.state = boost.readShort();
		me.locked = boost.readBoolean();
		me.id_ = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Mutex_2Configuration me = (Mutex_2Configuration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.locked);
		boost.writeInt(me.id_);
	}

}

