package test.compiled.example7_semaphore;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentInt;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;

@SuppressWarnings("all")
public class MainBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public MainBehavior(SymbolsTable symbols) {
		super("main", idSeed++, symbols);
	}

	public ReferencedArgumentInt getV0Ref() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.v0;
			}

			@Override
			public void set(Configuration configuration, int value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.v0 = value;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		MainConfiguration me = new MainConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- v0=");
		text.append(Integer.toString(me.v0));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" v0=");
		text.append(Integer.toString(me.v0));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		MainConfiguration me = new MainConfiguration();
		me.v0 = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		MainConfiguration me = (MainConfiguration) processConfiguration;
		boost.writeInt(me.v0);
	}

}

