package test.compiled.example7_semaphore;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		MainBehavior me = new MainBehavior(symbols);
		//Initializes variables
		me.createInitialConfiguration(null);
		
		BroadcastChannel svP0 = new BroadcastChannel(me.name+":svP0", symbols, 1, 1);
		BroadcastChannel svP1 = new BroadcastChannel(me.name+":svP1", symbols, 1, 1);
		BroadcastChannel svV2 = new BroadcastChannel(me.name+":svV2", symbols, 1, 1);
		BroadcastChannel svV3 = new BroadcastChannel(me.name+":svV3", symbols, 1, 1);
		channels = new Channel[] { svP0, svP1, svV2, svV3,  };
		
		components = new Component[] {
				me,
				new RBehavior(symbols, svP0),
				new RBehavior(symbols, svP1),
				new WBehavior(symbols, svV2),
				new WBehavior(symbols, svV3),
				new Sem_2_2Behavior(symbols, svP0, svP1, svV2, svV3, me.getV0Ref())
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

