package test.compiled.example7_semaphore;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentInt;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class Sem_2_2Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Dispatch = 1;

	private final BroadcastChannel p0;

	private final BroadcastChannel p1;

	private final BroadcastChannel v0;

	private final BroadcastChannel v1;

	private final ReferencedArgumentInt sizeRef;

	public Sem_2_2Behavior(SymbolsTable symbols, BroadcastChannel p0, BroadcastChannel p1, BroadcastChannel v0, BroadcastChannel v1, ReferencedArgumentInt size) {
		super("sem_2_2", idSeed++, symbols);
		this.p0 = p0;
		this.p1 = p1;
		this.v0 = v0;
		this.v1 = v1;
		this.sizeRef = size;
	}

	private final String[] stateNames = new String[] {"dispatch"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return p0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			if ( ((me.count) > (0)) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			int delta = 0;
			p0.input(id, actions);
			delta = p0.value(int.class,0);
			if ( p0.clockId != -1 ) {
				DBM.set(configuration.dbm, p0.clockId, 0);
			}
			me.count = (me.count) - (delta);
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			if ( ( !((me.count) > (0))) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return p1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			if ( ((me.count) > (0)) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			int delta = 0;
			p1.input(id, actions);
			delta = p1.value(int.class,0);
			if ( p1.clockId != -1 ) {
				DBM.set(configuration.dbm, p1.clockId, 0);
			}
			me.count = (me.count) - (delta);
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			if ( ( !((me.count) > (0))) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return v0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			int delta = 0;
			v0.input(id, actions);
			delta = v0.value(int.class,0);
			if ( v0.clockId != -1 ) {
				DBM.set(configuration.dbm, v0.clockId, 0);
			}
			me.count = (me.count) + (delta);
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return v1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != Dispatch) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Sem_2_2Configuration me = (Sem_2_2Configuration) configuration.behaviorConfigurations[id];
			int delta = 0;
			v1.input(id, actions);
			delta = v1.value(int.class,0);
			if ( v1.clockId != -1 ) {
				DBM.set(configuration.dbm, v1.clockId, 0);
			}
			me.count = (me.count) + (delta);
			me.state = Dispatch;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Sem_2_2Configuration me = new Sem_2_2Configuration();
		int delta;
		//Initial action code.
		me.state = Dispatch;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Sem_2_2Configuration me = (Sem_2_2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Sem_2_2Behavior.Dispatch: 
			text.append("@dispatch,");
			break;
		}
		text.append("\n\t- count=");
		text.append(Integer.toString(me.count));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Sem_2_2Configuration me = (Sem_2_2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Sem_2_2Behavior.Dispatch: 
			text.append("@dispatch,");
			break;
		}
		text.append(" count=");
		text.append(Integer.toString(me.count));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Sem_2_2Configuration me = new Sem_2_2Configuration();
		me.state = boost.readShort();
		me.count = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Sem_2_2Configuration me = (Sem_2_2Configuration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.count);
	}

}

