package test.compiled.example_defer;

import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Program;
import obp.explorer.runtime.Component;
import java.util.Map;
import java.util.HashMap;
import java.util.Collections;

public class Example_deferRoot implements Program {

	public Map<String, String> getMetaInformations() {
		return Collections.emptyMap();
	}

	private Map<String, Integer> ioQueueSizeMap;

	public int getIoQueueSize(String name) {
		if ( ioQueueSizeMap == null ) {
			ioQueueSizeMap = new HashMap<String, Integer>();
			ioQueueSizeMap.put("clientEP", 2 );
		}
		Integer size = ioQueueSizeMap.get(name);
		if ( size == null ) {
			throw new IllegalArgumentException("Queue named '"+ name +"' doesn't exists.");
		}
		return size.intValue();
	}

	public static T_message[] preprocessDeferred_ep_t(T_message[] eventPool, boolean[] deferMask) {
		T_message[] deferred = new T_message[] {};
		T_message[] result = new T_message[] {};
		boolean continue_ = true;
		while (( !( (eventPool.length == 0))) && (continue_)) {
			if ( FiacreQueueUtil.first(eventPool).getClass() == T_message.T_message_evtA.class) {
				if (deferMask[0]) {
					deferred = FiacreQueueUtil.enqueue(deferred, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			} else if ( FiacreQueueUtil.first(eventPool).getClass() == T_message.T_message_evtB.class) {
				if (deferMask[1]) {
					deferred = FiacreQueueUtil.enqueue(deferred, FiacreQueueUtil.first(eventPool));
					eventPool =  FiacreQueueUtil.dequeue(eventPool);
				} else {
					continue_ = false;
				}
			}
		}
		if ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		while ( !( (deferred.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(deferred));
			deferred =  FiacreQueueUtil.dequeue(deferred);
		}
		while ( !( (eventPool.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(eventPool));
			eventPool =  FiacreQueueUtil.dequeue(eventPool);
		}
		return result;
	}

	@Override
	public void unloadExternalLibrary() { }
	private Component root;

	@Override
	public Component getRoot(SymbolsTable symbols) {
		if (root == null) {
			root = new MainComposition(symbols);
		}
		return root;
	}

}

