package test.compiled.example_defer_lowlevel;

import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Program;
import obp.explorer.runtime.Component;
import java.util.Map;
import java.util.HashMap;
import java.util.Collections;

public class Example_defer_lowlevelRoot implements Program {

	public Map<String, String> getMetaInformations() {
		return Collections.emptyMap();
	}

	private Map<String, Integer> ioQueueSizeMap;

	public int getIoQueueSize(String name) {
		if ( ioQueueSizeMap == null ) {
			ioQueueSizeMap = new HashMap<String, Integer>();
			ioQueueSizeMap.put("ePool", 3 );
		}
		Integer size = ioQueueSizeMap.get(name);
		if ( size == null ) {
			throw new IllegalArgumentException("Queue named '"+ name +"' doesn't exists.");
		}
		return size.intValue();
	}

	public static final int FIFO_SIZE = 3;

	public static final int NUMBER_OF_MESSAGE = 2;

	public static T_message[] preprocessEventPool(T_message[] fifo, boolean[] ignoreMask, boolean[] deferMask) {
		T_message[] deferred = new T_message[] {};
		T_message[] result = new T_message[] {};
		boolean continue_ = true;
		while (( !( (fifo.length == 0))) && (continue_)) {
			if ( FiacreQueueUtil.first(fifo).getClass() == T_message.T_message_evtA.class) {
				if (deferMask[0]) {
					deferred = FiacreQueueUtil.enqueue(deferred, FiacreQueueUtil.first(fifo));
					fifo =  FiacreQueueUtil.dequeue(fifo);
				} else {
					if (ignoreMask[0]) {
						fifo =  FiacreQueueUtil.dequeue(fifo);
					} else {
						continue_ = false;
					}
				}
			} else if ( FiacreQueueUtil.first(fifo).getClass() == T_message.T_message_evtB.class) {
				if (deferMask[1]) {
					deferred = FiacreQueueUtil.enqueue(deferred, FiacreQueueUtil.first(fifo));
					fifo =  FiacreQueueUtil.dequeue(fifo);
				} else {
					if (ignoreMask[1]) {
						fifo =  FiacreQueueUtil.dequeue(fifo);
					} else {
						continue_ = false;
					}
				}
			}
		}
		if ( !( (fifo.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(fifo));
			fifo =  FiacreQueueUtil.dequeue(fifo);
		}
		while ( !( (deferred.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(deferred));
			deferred =  FiacreQueueUtil.dequeue(deferred);
		}
		while ( !( (fifo.length == 0))) {
			result = FiacreQueueUtil.enqueue(result, FiacreQueueUtil.first(fifo));
			fifo =  FiacreQueueUtil.dequeue(fifo);
		}
		return result;
	}

	@Override
	public void unloadExternalLibrary() { }
	private Component root;

	@Override
	public Component getRoot(SymbolsTable symbols) {
		if (root == null) {
			root = new MainComposition(symbols);
		}
		return root;
	}

}

