package test.compiled.example_defer_lowlevel;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainConfiguration extends BehaviorConfiguration {

	public T_message[] ePool;

	//Create initial configuration
	public MainConfiguration() {
		this.ePool = new T_message[] {};
	}

	//Create configuration as a copy
	public MainConfiguration(MainConfiguration other) {
		this.ePool = new T_message[other.ePool.length];
		for (int i=0; i<other.ePool.length; i++) {
			this.ePool[i] = T_message.copy(other.ePool[i]);
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new MainConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof MainConfiguration) {
			MainConfiguration other = (MainConfiguration) object;
			if (!Arrays.deepEquals(ePool, other.ePool)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.deepHashCode(ePool);
		return total;
	}

}

