package test.compiled.example_defer_lowlevel;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class SysBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short X0 = 1;

	public static final short X1y0 = 2;

	public static final short X1y1 = 3;

	private final ReferencedArgument<T_message[]> fifoRef;

	public SysBehavior(SymbolsTable symbols, ReferencedArgument<T_message[]> fifo) {
		super("sys", idSeed++, symbols);
		this.fifoRef = fifo;
	}

	private final String[] stateNames = new String[] {"x0", "x1y0", "x1y1"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			T_message[] fifo = fifoRef.get(configuration);
			modifiedBehaviors[fifoRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != X0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			T_message[] fifo = fifoRef.get(configuration);
			try {
				fifo = Example_defer_lowlevelRoot.preprocessEventPool(fifo, new boolean[] {false, true}, new boolean[] {false, false});
				if ( !( (fifo.length == 0))) {
					if ( FiacreQueueUtil.first(fifo).getClass() == T_message.T_message_evtA.class) {
						fifo =  FiacreQueueUtil.dequeue(id, fifo, actions);
						me.state = X1y0;
						if (true) return true;
					} else {
					}
				}
				me.state = X0;
				if (true) return true;
			} finally {
				fifoRef.set(configuration, fifo);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			T_message[] fifo = fifoRef.get(configuration);
			modifiedBehaviors[fifoRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != X1y0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			T_message[] fifo = fifoRef.get(configuration);
			try {
				if ( !( (fifo.length == 0))) {
					if ( FiacreQueueUtil.first(fifo).getClass() == T_message.T_message_evtA.class) {
						fifo =  FiacreQueueUtil.dequeue(id, fifo, actions);
						me.state = X1y1;
						if (true) return true;
					} else if ( FiacreQueueUtil.first(fifo).getClass() == T_message.T_message_evtB.class) {
						fifo =  FiacreQueueUtil.dequeue(id, fifo, actions);
						me.state = X1y1;
						if (true) return true;
					} else {
						if (true) { return false; }
					}
				}
				me.state = X1y0;
				if (true) return true;
			} finally {
				fifoRef.set(configuration, fifo);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			T_message[] fifo = fifoRef.get(configuration);
			modifiedBehaviors[fifoRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != X1y1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SysConfiguration me = (SysConfiguration) configuration.behaviorConfigurations[id];
			T_message[] fifo = fifoRef.get(configuration);
			try {
				fifo = Example_defer_lowlevelRoot.preprocessEventPool(fifo, new boolean[] {false, false}, new boolean[] {true, false});
				if ( !( (fifo.length == 0))) {
					if ( FiacreQueueUtil.first(fifo).getClass() == T_message.T_message_evtB.class) {
						fifo =  FiacreQueueUtil.dequeue(id, fifo, actions);
						me.state = X0;
						if (true) return true;
					} else {
					}
				}
				me.state = X1y1;
				if (true) return true;
			} finally {
				fifoRef.set(configuration, fifo);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		SysConfiguration me = new SysConfiguration();
		//Initial action code.
		me.state = X0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SysConfiguration me = (SysConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case SysBehavior.X0: 
			text.append("@x0,");
			break;
		case SysBehavior.X1y0: 
			text.append("@x1y0,");
			break;
		case SysBehavior.X1y1: 
			text.append("@x1y1,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SysConfiguration me = (SysConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case SysBehavior.X0: 
			text.append("@x0,");
			break;
		case SysBehavior.X1y0: 
			text.append("@x1y0,");
			break;
		case SysBehavior.X1y1: 
			text.append("@x1y1,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		SysConfiguration me = new SysConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		SysConfiguration me = (SysConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

