package test.compiled.example_fifo_ops;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class PConfiguration extends BehaviorConfiguration {

	public short state;

	public int[] fifo;

	public int e;

	//Create initial configuration
	public PConfiguration() {
		this.fifo = new int[] {};
		this.e =  - (1);
	}

	//Create configuration as a copy
	public PConfiguration(PConfiguration other) {
		this.state = other.state;
		this.fifo = new int[other.fifo.length];
		for (int i=0; i<other.fifo.length; i++) {
			this.fifo[i] = other.fifo[i];
		}
		this.e = other.e;
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new PConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof PConfiguration) {
			PConfiguration other = (PConfiguration) object;
			if (state != other.state) return false;
			if (!Arrays.equals(fifo, other.fifo)) return false;
			if (e != other.e) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + state;
		total = total * 37 + Arrays.hashCode(fifo);
		total = total * 37 + e;
		return total;
	}

}

