package test.compiled.example_foreach;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public MainBehavior(SymbolsTable symbols) {
		super("main", idSeed++, symbols);
	}

	public ReferencedArgument<int[]> getXRef() {
return 		new ReferencedArgument<int[]>(id) {
			@Override
			public int[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.x;
			}

			@Override
			public void set(Configuration configuration, int[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.x = value;
			}

			@Override
			public  Class<int[]> getArgumentType() {
				return int[].class;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		MainConfiguration me = new MainConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- x=");
		text.append(Arrays.toString(me.x));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" x=");
		text.append(Arrays.toString(me.x));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		MainConfiguration me = new MainConfiguration();
		me.x = new int[3];
		for (int i=0; i<me.x.length; i++) {
			me.x[i] = boost.readInt();
		}
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		MainConfiguration me = (MainConfiguration) processConfiguration;
		for (int i=0; i<me.x.length; i++) {
			boost.writeInt(me.x[i]);
		}
	}

}

