package test.compiled.example_foreach;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainConfiguration extends BehaviorConfiguration {

	public int[] x;

	//Create initial configuration
	public MainConfiguration() {
		this.x = new int[] {1, 2, 3};
	}

	//Create configuration as a copy
	public MainConfiguration(MainConfiguration other) {
		this.x = new int[3];
		for (int i=0; i<other.x.length; i++) {
			this.x[i] = other.x[i];
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new MainConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof MainConfiguration) {
			MainConfiguration other = (MainConfiguration) object;
			if (!Arrays.equals(x, other.x)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.hashCode(x);
		return total;
	}

}

