package test.compiled.example_foreach;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class TotoBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short X = 1;

	private final ReferencedArgument<int[]> xxRef;

	public int i;

	public TotoBehavior(SymbolsTable symbols, ReferencedArgument<int[]> xx) {
		super("toto", idSeed++, symbols);
		this.xxRef = xx;
		this.i = 0;
	}

	private final String[] stateNames = new String[] {"x"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			TotoConfiguration me = (TotoConfiguration) configuration.behaviorConfigurations[id];
			int[] xx = xxRef.get(configuration);
			modifiedBehaviors[xxRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			TotoConfiguration me = (TotoConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != X) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final TotoConfiguration me = (TotoConfiguration) configuration.behaviorConfigurations[id];
			int[] xx = xxRef.get(configuration);
			try {
				for ( i = 0; i <= 2; i++ ) {
					//Start copy variable 'xx'.
					{
						int[] __tmp;
						__tmp = new int[3];
						for (int l=0; l<xx.length; l++) {
							__tmp[l] = xx[l];
						}
						xx = __tmp;
					}
					//End copy variable 'xx'.
					xx[i] = (i) * (2);
				}
			} finally {
				xxRef.set(configuration, xx);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		TotoConfiguration me = new TotoConfiguration();
		//Initial action code.
		me.state = X;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		TotoConfiguration me = (TotoConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case TotoBehavior.X: 
			text.append("@x,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		TotoConfiguration me = (TotoConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case TotoBehavior.X: 
			text.append("@x,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		TotoConfiguration me = new TotoConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		TotoConfiguration me = (TotoConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

