package test.compiled.example_portmap;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel chan0 = new BroadcastChannel(name+":chan0", symbols, 1, 1);
		BroadcastChannel chan1 = new BroadcastChannel(name+":chan1", symbols, 1, 1);
		BroadcastChannel chan2 = new BroadcastChannel(name+":chan2", symbols, 1, 1);
		channels = new Channel[] { chan0, chan1, chan2,  };
		
		components = new Component[] {
				new PBehavior(symbols, chan1, chan0, chan2),
				new DBehavior(symbols, chan1, chan2, chan0)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

