package test.compiled.example_single_transition_types_by_luka;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public MainBehavior(SymbolsTable symbols) {
		super("main", idSeed++, symbols);
	}

	public ReferencedArgument<T_message[]> getMsgEventPoolRef() {
return 		new ReferencedArgument<T_message[]>(id) {
			@Override
			public T_message[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.msgEventPool;
			}

			@Override
			public void set(Configuration configuration, T_message[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.msgEventPool = value;
			}

			@Override
			public  Class<T_message[]> getArgumentType() {
				return T_message[].class;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		MainConfiguration me = new MainConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- msgEventPool=");
		text.append(Arrays.deepToString(me.msgEventPool));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" msgEventPool=");
		text.append(Arrays.deepToString(me.msgEventPool));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		MainConfiguration me = new MainConfiguration();
		me.msgEventPool = new T_message[3];
		me.msgEventPool = new T_message[boost.readInt()];
		for (int i=0; i<me.msgEventPool.length; i++) {
			me.msgEventPool[i] = boost.readObject(T_message.class);
		}
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		MainConfiguration me = (MainConfiguration) processConfiguration;
		boost.writeInt(me.msgEventPool.length);
		for (int i=0; i<me.msgEventPool.length; i++) {
			boost.writeObject(me.msgEventPool[i]);
		}
	}

}

