package test.compiled.example_single_transition_types_by_luka;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainConfiguration extends BehaviorConfiguration {

	public T_message[] msgEventPool;

	//Create initial configuration
	public MainConfiguration() {
		this.msgEventPool = new T_message[] {};
	}

	//Create configuration as a copy
	public MainConfiguration(MainConfiguration other) {
		this.msgEventPool = new T_message[other.msgEventPool.length];
		for (int i=0; i<other.msgEventPool.length; i++) {
			this.msgEventPool[i] = T_message.copy(other.msgEventPool[i]);
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new MainConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof MainConfiguration) {
			MainConfiguration other = (MainConfiguration) object;
			if (!Arrays.deepEquals(msgEventPool, other.msgEventPool)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.deepHashCode(msgEventPool);
		return total;
	}

}

