package test.compiled.example_single_transition_types_by_luka;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class SusBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S0 = 1;

	public static final short S1 = 2;

	public static final short S2 = 3;

	private final ReferencedArgument<T_message[]> eventPoolRef;

	public SusBehavior(SymbolsTable symbols, ReferencedArgument<T_message[]> eventPool) {
		super("sus", idSeed++, symbols);
		this.eventPoolRef = eventPool;
	}

	private final String[] stateNames = new String[] {"s0", "s1", "s2"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			me.guard =  !(me.guard);
			me.state = S0;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			try {
				if ( !( (eventPool.length == 0)) == true) {
					eventPool = Example_single_transition_types_by_lukaRoot.preprocessDeferred_t_msgEventPool(eventPool, new boolean[] { !(me.guard), false});
					if ( FiacreQueueUtil.first(eventPool).getClass() == T_message.T_message_evtA.class) {
						eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				if (me.guard == true) {
				} else {
					if (true) { return false; }
				}
				me.state = S1;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			try {
				if ( !( (eventPool.length == 0)) == true) {
					eventPool = Example_single_transition_types_by_lukaRoot.preprocessDeferred_t_msgEventPool(eventPool, new boolean[] { !(me.guard), false});
					if ( FiacreQueueUtil.first(eventPool).getClass() == T_message.T_message_evtB.class) {
						eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S1;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			try {
				if ( !( (eventPool.length == 0)) == true) {
					eventPool = Example_single_transition_types_by_lukaRoot.preprocessDeferred_t_msgEventPool(eventPool, new boolean[] {false, false});
					if ( FiacreQueueUtil.first(eventPool).getClass() == T_message.T_message_evtA.class) {
						eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S2;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			try {
				if ( !( (eventPool.length == 0)) == true) {
					eventPool = Example_single_transition_types_by_lukaRoot.preprocessDeferred_t_msgEventPool(eventPool, new boolean[] {false, false});
					if ( FiacreQueueUtil.first(eventPool).getClass() == T_message.T_message_evtB.class) {
						eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				if (me.guard == true) {
				} else if (me.guard == false) {
					me.state = S1;
					if (true) return true;
				} else {
					if (true) { return false; }
				}
				me.state = S2;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			modifiedBehaviors[eventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S2) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final SusConfiguration me = (SusConfiguration) configuration.behaviorConfigurations[id];
			T_message[] eventPool = eventPoolRef.get(configuration);
			try {
				if ( !( (eventPool.length == 0)) == true) {
					eventPool = Example_single_transition_types_by_lukaRoot.preprocessDeferred_t_msgEventPool(eventPool, new boolean[] {true, false});
					if ( FiacreQueueUtil.first(eventPool).getClass() == T_message.T_message_evtB.class) {
						eventPool =  FiacreQueueUtil.dequeue(id, eventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S0;
				if (true) return true;
			} finally {
				eventPoolRef.set(configuration, eventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		SusConfiguration me = new SusConfiguration();
		//Initial action code.
		me.guard = false;
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SusConfiguration me = (SusConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case SusBehavior.S0: 
			text.append("@s0,");
			break;
		case SusBehavior.S1: 
			text.append("@s1,");
			break;
		case SusBehavior.S2: 
			text.append("@s2,");
			break;
		}
		text.append("\n\t- guard=");
		text.append(Boolean.toString(me.guard));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		SusConfiguration me = (SusConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case SusBehavior.S0: 
			text.append("@s0,");
			break;
		case SusBehavior.S1: 
			text.append("@s1,");
			break;
		case SusBehavior.S2: 
			text.append("@s2,");
			break;
		}
		text.append(" guard=");
		text.append(Boolean.toString(me.guard));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		SusConfiguration me = new SusConfiguration();
		me.state = boost.readShort();
		me.guard = boost.readBoolean();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		SusConfiguration me = (SusConfiguration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeBoolean(me.guard);
	}

}

