package test.compiled.pingpong;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public MainBehavior(SymbolsTable symbols) {
		super("main", idSeed++, symbols);
	}

	public ReferencedArgument<PingerEvents[]> getToThePingerRef() {
return 		new ReferencedArgument<PingerEvents[]>(id) {
			@Override
			public PingerEvents[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.toThePinger;
			}

			@Override
			public void set(Configuration configuration, PingerEvents[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.toThePinger = value;
			}

			@Override
			public  Class<PingerEvents[]> getArgumentType() {
				return PingerEvents[].class;
			}

		}

;	}

	public ReferencedArgument<PongerEvents[]> getToThePongerRef() {
return 		new ReferencedArgument<PongerEvents[]>(id) {
			@Override
			public PongerEvents[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.toThePonger;
			}

			@Override
			public void set(Configuration configuration, PongerEvents[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.toThePonger = value;
			}

			@Override
			public  Class<PongerEvents[]> getArgumentType() {
				return PongerEvents[].class;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		MainConfiguration me = new MainConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- toThePinger=");
		text.append(Arrays.deepToString(me.toThePinger));
		text.append("\n\t- toThePonger=");
		text.append(Arrays.deepToString(me.toThePonger));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" toThePinger=");
		text.append(Arrays.deepToString(me.toThePinger));
		text.append(" toThePonger=");
		text.append(Arrays.deepToString(me.toThePonger));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		MainConfiguration me = new MainConfiguration();
		me.toThePinger = new PingerEvents[PingpongRoot.MAX_BUF];
		me.toThePinger = new PingerEvents[boost.readInt()];
		for (int i=0; i<me.toThePinger.length; i++) {
			me.toThePinger[i] = boost.readObject(PingerEvents.class);
		}
		me.toThePonger = new PongerEvents[PingpongRoot.MAX_BUF];
		me.toThePonger = new PongerEvents[boost.readInt()];
		for (int i=0; i<me.toThePonger.length; i++) {
			me.toThePonger[i] = boost.readObject(PongerEvents.class);
		}
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		MainConfiguration me = (MainConfiguration) processConfiguration;
		boost.writeInt(me.toThePinger.length);
		for (int i=0; i<me.toThePinger.length; i++) {
			boost.writeObject(me.toThePinger[i]);
		}
		boost.writeInt(me.toThePonger.length);
		for (int i=0; i<me.toThePonger.length; i++) {
			boost.writeObject(me.toThePonger[i]);
		}
	}

}

