package test.compiled.pingpong;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainConfiguration extends BehaviorConfiguration {

	public PingerEvents[] toThePinger;

	public PongerEvents[] toThePonger;

	//Create initial configuration
	public MainConfiguration() {
		this.toThePinger = new PingerEvents[] {};
		this.toThePonger = new PongerEvents[] {};
	}

	//Create configuration as a copy
	public MainConfiguration(MainConfiguration other) {
		this.toThePinger = new PingerEvents[other.toThePinger.length];
		for (int i=0; i<other.toThePinger.length; i++) {
			this.toThePinger[i] = PingerEvents.copy(other.toThePinger[i]);
		}
		this.toThePonger = new PongerEvents[other.toThePonger.length];
		for (int i=0; i<other.toThePonger.length; i++) {
			this.toThePonger[i] = PongerEvents.copy(other.toThePonger[i]);
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new MainConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof MainConfiguration) {
			MainConfiguration other = (MainConfiguration) object;
			if (!Arrays.deepEquals(toThePinger, other.toThePinger)) return false;
			if (!Arrays.deepEquals(toThePonger, other.toThePonger)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.deepHashCode(toThePinger);
		total = total * 37 + Arrays.deepHashCode(toThePonger);
		return total;
	}

}

