package test.compiled.pingpong;

import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Program;
import obp.explorer.runtime.Component;
import java.util.Map;
import java.util.HashMap;
import java.util.Collections;

public class PingpongRoot implements Program {

	public Map<String, String> getMetaInformations() {
		return Collections.emptyMap();
	}

	private Map<String, Integer> ioQueueSizeMap;

	public int getIoQueueSize(String name) {
		if ( ioQueueSizeMap == null ) {
			ioQueueSizeMap = new HashMap<String, Integer>();
			ioQueueSizeMap.put("toThePinger", 5 );
			ioQueueSizeMap.put("toThePonger", 5 );
		}
		Integer size = ioQueueSizeMap.get(name);
		if ( size == null ) {
			throw new IllegalArgumentException("Queue named '"+ name +"' doesn't exists.");
		}
		return size.intValue();
	}

	public static final int MAX_BUF = 5;

	@Override
	public void unloadExternalLibrary() { }
	private Component root;

	@Override
	public Component getRoot(SymbolsTable symbols) {
		if (root == null) {
			root = new MainComposition(symbols);
		}
		return root;
	}

}

