package test.compiled.pingpong_multiple;

import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainConfiguration extends BehaviorConfiguration {

	public PingerEvents[] toThePinger;

	public PongerEvents[] toThePonger1;

	public PongerEvents[] toThePonger2;

	//Create initial configuration
	public MainConfiguration() {
		this.toThePinger = new PingerEvents[] {};
		this.toThePonger1 = new PongerEvents[] {};
		this.toThePonger2 = new PongerEvents[] {};
	}

	//Create configuration as a copy
	public MainConfiguration(MainConfiguration other) {
		this.toThePinger = new PingerEvents[other.toThePinger.length];
		for (int i=0; i<other.toThePinger.length; i++) {
			this.toThePinger[i] = PingerEvents.copy(other.toThePinger[i]);
		}
		this.toThePonger1 = new PongerEvents[other.toThePonger1.length];
		for (int i=0; i<other.toThePonger1.length; i++) {
			this.toThePonger1[i] = PongerEvents.copy(other.toThePonger1[i]);
		}
		this.toThePonger2 = new PongerEvents[other.toThePonger2.length];
		for (int i=0; i<other.toThePonger2.length; i++) {
			this.toThePonger2[i] = PongerEvents.copy(other.toThePonger2[i]);
		}
	}

	@Override
	public BehaviorConfiguration createCopy() {
		return new MainConfiguration(this);
	}

	@Override
	public boolean equals(Object object) {
		if (object instanceof MainConfiguration) {
			MainConfiguration other = (MainConfiguration) object;
			if (!Arrays.deepEquals(toThePinger, other.toThePinger)) return false;
			if (!Arrays.deepEquals(toThePonger1, other.toThePonger1)) return false;
			if (!Arrays.deepEquals(toThePonger2, other.toThePonger2)) return false;
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		int total = 17;
		total = total * 37 + Arrays.deepHashCode(toThePinger);
		total = total * 37 + Arrays.deepHashCode(toThePonger1);
		total = total * 37 + Arrays.deepHashCode(toThePonger2);
		return total;
	}

}

