package test.compiled.pingpong_multiple;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class PingerBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short S1 = 1;

	public static final short S0 = 2;

	public static final short Idle = 3;

	private final ReferencedArgument<PingerEvents[]> myEventPoolRef;

	private final ReferencedArgument<PongerEvents[]> itsPonger1Ref;

	private final ReferencedArgument<PongerEvents[]> itsPonger2Ref;

	public PingerBehavior(SymbolsTable symbols, ReferencedArgument<PingerEvents[]> myEventPool, ReferencedArgument<PongerEvents[]> itsPonger1, ReferencedArgument<PongerEvents[]> itsPonger2) {
		super("Pinger", idSeed++, symbols);
		this.myEventPoolRef = myEventPool;
		this.itsPonger1Ref = itsPonger1;
		this.itsPonger2Ref = itsPonger2;
	}

	private final String[] stateNames = new String[] {"s1", "s0", "idle"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			PongerEvents[] itsPonger1 = itsPonger1Ref.get(configuration);
			PongerEvents[] itsPonger2 = itsPonger2Ref.get(configuration);
			modifiedBehaviors[itsPonger1Ref.ownerId] = true;
			modifiedBehaviors[itsPonger2Ref.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			PongerEvents[] itsPonger1 = itsPonger1Ref.get(configuration);
			PongerEvents[] itsPonger2 = itsPonger2Ref.get(configuration);
			try {
				if ( !( (itsPonger1.length >= 3 )) == true) {
					itsPonger1 = FiacreQueueUtil.enqueue(id, itsPonger1,new PongerEvents.PongerEvents_ping(), actions);
				} else {
					if (true) { return false; }
				}
				if ( !( (itsPonger2.length >= 3 )) == true) {
					itsPonger2 = FiacreQueueUtil.enqueue(id, itsPonger2,new PongerEvents.PongerEvents_ping(), actions);
				} else {
					if (true) { return false; }
				}
				me.state = S1;
				if (true) return true;
			} finally {
				itsPonger1Ref.set(configuration, itsPonger1);
				itsPonger2Ref.set(configuration, itsPonger2);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			PingerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S0) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			PingerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == PingerEvents.PingerEvents_pong.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = S0;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			PingerEvents[] myEventPool = myEventPoolRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != S1) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			PingerEvents[] myEventPool = myEventPoolRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == PingerEvents.PingerEvents_pong.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				me.state = Idle;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			PongerEvents[] itsPonger1 = itsPonger1Ref.get(configuration);
			PingerEvents[] myEventPool = myEventPoolRef.get(configuration);
			PongerEvents[] itsPonger2 = itsPonger2Ref.get(configuration);
			modifiedBehaviors[itsPonger1Ref.ownerId] = true;
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
			modifiedBehaviors[itsPonger2Ref.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PingerConfiguration me = (PingerConfiguration) configuration.behaviorConfigurations[id];
			PongerEvents[] itsPonger1 = itsPonger1Ref.get(configuration);
			PingerEvents[] myEventPool = myEventPoolRef.get(configuration);
			PongerEvents[] itsPonger2 = itsPonger2Ref.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == PingerEvents.PingerEvents_pong.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				if ( !( (itsPonger1.length >= 3 )) == true) {
					itsPonger1 = FiacreQueueUtil.enqueue(id, itsPonger1,new PongerEvents.PongerEvents_ping(), actions);
				} else {
					if (true) { return false; }
				}
				if ( !( (itsPonger2.length >= 3 )) == true) {
					itsPonger2 = FiacreQueueUtil.enqueue(id, itsPonger2,new PongerEvents.PongerEvents_ping(), actions);
				} else {
					if (true) { return false; }
				}
				me.state = Idle;
				if (true) return true;
			} finally {
				itsPonger1Ref.set(configuration, itsPonger1);
				myEventPoolRef.set(configuration, myEventPool);
				itsPonger2Ref.set(configuration, itsPonger2);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		PingerConfiguration me = new PingerConfiguration();
		//Initial action code.
		me.state = S0;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		PingerConfiguration me = (PingerConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case PingerBehavior.S1: 
			text.append("@s1,");
			break;
		case PingerBehavior.S0: 
			text.append("@s0,");
			break;
		case PingerBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		PingerConfiguration me = (PingerConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case PingerBehavior.S1: 
			text.append("@s1,");
			break;
		case PingerBehavior.S0: 
			text.append("@s0,");
			break;
		case PingerBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		PingerConfiguration me = new PingerConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		PingerConfiguration me = (PingerConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

