package test.compiled.pingpong_multiple;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.FiacreQueueUtil;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;

@SuppressWarnings("all")
public class PongerBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short Idle = 1;

	private final ReferencedArgument<PongerEvents[]> myEventPoolRef;

	private final ReferencedArgument<PingerEvents[]> itsPingerRef;

	public PongerBehavior(SymbolsTable symbols, ReferencedArgument<PongerEvents[]> myEventPool, ReferencedArgument<PingerEvents[]> itsPinger) {
		super("Ponger", idSeed++, symbols);
		this.myEventPoolRef = myEventPool;
		this.itsPingerRef = itsPinger;
	}

	private final String[] stateNames = new String[] {"idle"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public void updateModifiedBehaviors(Configuration configuration, ExplorationContext context, boolean[] modifiedBehaviors) {
			PongerConfiguration me = (PongerConfiguration) configuration.behaviorConfigurations[id];
			PongerEvents[] myEventPool = myEventPoolRef.get(configuration);
			PingerEvents[] itsPinger = itsPingerRef.get(configuration);
			modifiedBehaviors[myEventPoolRef.ownerId] = true;
			modifiedBehaviors[itsPingerRef.ownerId] = true;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			PongerConfiguration me = (PongerConfiguration) configuration.behaviorConfigurations[id];
			if (me.state != Idle) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final PongerConfiguration me = (PongerConfiguration) configuration.behaviorConfigurations[id];
			PongerEvents[] myEventPool = myEventPoolRef.get(configuration);
			PingerEvents[] itsPinger = itsPingerRef.get(configuration);
			try {
				if ( !( (myEventPool.length == 0)) == true) {
					if ( FiacreQueueUtil.first(myEventPool).getClass() == PongerEvents.PongerEvents_ping.class) {
						myEventPool =  FiacreQueueUtil.dequeue(id, myEventPool, actions);
					} else {
						if (true) { return false; }
					}
				} else {
					if (true) { return false; }
				}
				if ( !( (itsPinger.length >= 3 )) == true) {
					itsPinger = FiacreQueueUtil.enqueue(id, itsPinger,new PingerEvents.PingerEvents_pong(), actions);
				} else {
					if (true) { return false; }
				}
				me.state = Idle;
				if (true) return true;
			} finally {
				myEventPoolRef.set(configuration, myEventPool);
				itsPingerRef.set(configuration, itsPinger);
			}
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		PongerConfiguration me = new PongerConfiguration();
		//Initial action code.
		me.state = Idle;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		PongerConfiguration me = (PongerConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case PongerBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		PongerConfiguration me = (PongerConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case PongerBehavior.Idle: 
			text.append("@idle,");
			break;
		}
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		PongerConfiguration me = new PongerConfiguration();
		me.state = boost.readShort();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		PongerConfiguration me = (PongerConfiguration) processConfiguration;
		boost.writeShort(me.state);
	}

}

