package test.compiled.pingpong_multiple_signed;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ReferencedArgumentInt;
import obp.explorer.runtime.ReferencedArgument;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import java.util.Arrays;

@SuppressWarnings("all")
public class MainBehavior extends ProcessBehavior {

	private static short idSeed = 1;

	public MainBehavior(SymbolsTable symbols) {
		super("main", idSeed++, symbols);
	}

	public ReferencedArgument<PongerEvents[]> getToThePonger2Ref() {
return 		new ReferencedArgument<PongerEvents[]>(id) {
			@Override
			public PongerEvents[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.toThePonger2;
			}

			@Override
			public void set(Configuration configuration, PongerEvents[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.toThePonger2 = value;
			}

			@Override
			public  Class<PongerEvents[]> getArgumentType() {
				return PongerEvents[].class;
			}

		}

;	}

	public ReferencedArgument<PongerEvents[]> getToThePonger1Ref() {
return 		new ReferencedArgument<PongerEvents[]>(id) {
			@Override
			public PongerEvents[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.toThePonger1;
			}

			@Override
			public void set(Configuration configuration, PongerEvents[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.toThePonger1 = value;
			}

			@Override
			public  Class<PongerEvents[]> getArgumentType() {
				return PongerEvents[].class;
			}

		}

;	}

	public ReferencedArgument<PingerEvents[]> getToThePingerRef() {
return 		new ReferencedArgument<PingerEvents[]>(id) {
			@Override
			public PingerEvents[] get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.toThePinger;
			}

			@Override
			public void set(Configuration configuration, PingerEvents[] value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.toThePinger = value;
			}

			@Override
			public  Class<PingerEvents[]> getArgumentType() {
				return PingerEvents[].class;
			}

		}

;	}

	public ReferencedArgumentInt getV0Ref() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.v0;
			}

			@Override
			public void set(Configuration configuration, int value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.v0 = value;
			}

		}

;	}

	public ReferencedArgumentInt getV1Ref() {
return 		new ReferencedArgumentInt(id) {
			@Override
			public int get(Configuration configuration) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				return me.v1;
			}

			@Override
			public void set(Configuration configuration, int value) {
				MainConfiguration me = (MainConfiguration) configuration.behaviorConfigurations[ownerId];
				me.v1 = value;
			}

		}

;	}

	private final Transition[] transitions = new Transition[0];

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		MainConfiguration me = new MainConfiguration();
		//Initial action code.
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("component: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append("\n\t- toThePinger=");
		text.append(Arrays.deepToString(me.toThePinger));
		text.append("\n\t- toThePonger1=");
		text.append(Arrays.deepToString(me.toThePonger1));
		text.append("\n\t- toThePonger2=");
		text.append(Arrays.deepToString(me.toThePonger2));
		text.append("\n\t- v0=");
		text.append(Integer.toString(me.v0));
		text.append("\n\t- v1=");
		text.append(Integer.toString(me.v1));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		MainConfiguration me = (MainConfiguration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		text.append(" toThePinger=");
		text.append(Arrays.deepToString(me.toThePinger));
		text.append(" toThePonger1=");
		text.append(Arrays.deepToString(me.toThePonger1));
		text.append(" toThePonger2=");
		text.append(Arrays.deepToString(me.toThePonger2));
		text.append(" v0=");
		text.append(Integer.toString(me.v0));
		text.append(" v1=");
		text.append(Integer.toString(me.v1));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		MainConfiguration me = new MainConfiguration();
		me.toThePinger = new PingerEvents[Pingpong_multiple_signedRoot.MAX_BUF];
		me.toThePinger = new PingerEvents[boost.readInt()];
		for (int i=0; i<me.toThePinger.length; i++) {
			me.toThePinger[i] = boost.readObject(PingerEvents.class);
		}
		me.toThePonger1 = new PongerEvents[Pingpong_multiple_signedRoot.MAX_BUF];
		me.toThePonger1 = new PongerEvents[boost.readInt()];
		for (int i=0; i<me.toThePonger1.length; i++) {
			me.toThePonger1[i] = boost.readObject(PongerEvents.class);
		}
		me.toThePonger2 = new PongerEvents[Pingpong_multiple_signedRoot.MAX_BUF];
		me.toThePonger2 = new PongerEvents[boost.readInt()];
		for (int i=0; i<me.toThePonger2.length; i++) {
			me.toThePonger2[i] = boost.readObject(PongerEvents.class);
		}
		me.v0 = boost.readInt();
		me.v1 = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		MainConfiguration me = (MainConfiguration) processConfiguration;
		boost.writeInt(me.toThePinger.length);
		for (int i=0; i<me.toThePinger.length; i++) {
			boost.writeObject(me.toThePinger[i]);
		}
		boost.writeInt(me.toThePonger1.length);
		for (int i=0; i<me.toThePonger1.length; i++) {
			boost.writeObject(me.toThePonger1[i]);
		}
		boost.writeInt(me.toThePonger2.length);
		for (int i=0; i<me.toThePonger2.length; i++) {
			boost.writeObject(me.toThePonger2[i]);
		}
		boost.writeInt(me.v0);
		boost.writeInt(me.v1);
	}

}

