package test.compiled.pingpong_multiple_signed;

import org.xid.basics.serializer.BoostObject;
import org.xid.basics.serializer.Boost;

public abstract class PingerEvents implements BoostObject {

	public static class PingerEvents_pong extends PingerEvents {

		public int value;

		public PingerEvents_pong() {
			this.value = 1;
		}

		public PingerEvents_pong(int value) {
			this.value = value;
		}

		public PingerEvents_pong(PingerEvents_pong other) {
			this.value = other.value;
		}

		public PingerEvents_pong(Boost boost) {
			boost.register(this);
			this.value = boost.readInt();
		}

		public void writeToBoost(Boost boost) {
			boost.writeInt(value);
		}

		@Override
		public boolean equals(Object object) {
			if (object instanceof PingerEvents_pong) {
				PingerEvents_pong other = (PingerEvents_pong) object;
				if (value != other.value) return false;
				return true;
			}
			return false;
		}

		@Override
		public int hashCode() {
			int total = 831435;
			total = total * 37 + value;
			return total;
		}

		public String toString() {
			StringBuilder text = new StringBuilder();
			text.append("{PingerEvents_pong");
			text.append("@");
			text.append(Integer.toString(value));
			text.append("}");
			return text.toString();
		}

	}

	public static PingerEvents copy(PingerEvents other) {
		if (other == null) {
			return null;
		}
		else if ( other.getClass() == PingerEvents_pong.class ) {
			return new PingerEvents_pong((PingerEvents_pong) other);
		}
		throw new IllegalArgumentException("Unknown constructor for 'PingerEvents'.");
	}

}

