package test.compiled.timer_api;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel vStart0 = new BroadcastChannel(name+":vStart0", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel vStop1 = new BroadcastChannel(name+":vStop1", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel vTimeout2 = new BroadcastChannel(name+":vTimeout2", symbols, 1, 1, 0, false, 0, false);
		channels = new Channel[] { vStart0, vStop1, vTimeout2,  };
		
		components = new Component[] {
				new PBehavior(symbols, vStart0, vStop1, vTimeout2),
				new Tim_1_1_1Behavior(symbols, vStart0, vStop1, vTimeout2)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

