package test.compiled.timer_api_shared;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel timStart0 = new BroadcastChannel(name+":timStart0", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timStart1 = new BroadcastChannel(name+":timStart1", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timStop2 = new BroadcastChannel(name+":timStop2", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timStop3 = new BroadcastChannel(name+":timStop3", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timTimeout4 = new BroadcastChannel(name+":timTimeout4", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timTimeout5 = new BroadcastChannel(name+":timTimeout5", symbols, 1, 1, 0, false, 0, false);
		channels = new Channel[] { timStart0, timStart1, timStop2, timStop3, timTimeout4, timTimeout5,  };
		
		components = new Component[] {
				new PBehavior(symbols, timStart0, timStop2, timTimeout4),
				new PBehavior(symbols, timStart1, timStop3, timTimeout5),
				new Tim_2_2_2Behavior(symbols, timStart0, timStart1, timStop2, timStop3, timTimeout4, timTimeout5)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

