package test.compiled.timer_api_shared;

import org.xid.basics.serializer.Boost;
import obp.explorer.runtime.obs.DelayAction;
import obp.explorer.runtime.obs.AtomicAction;
import obp.explorer.runtime.fiacre.WaitChannel;
import obp.explorer.runtime.core.Transition;
import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.ProcessBehavior;
import obp.explorer.runtime.ExplorationContext;
import obp.explorer.runtime.DBM;
import obp.explorer.runtime.Configuration;
import obp.explorer.runtime.BehaviorConfiguration;
import obp.explorer.runtime.AbstractCallable;
import java.util.List;
import java.util.Arrays;

@SuppressWarnings("all")
public class Tim_2_2_2Behavior extends ProcessBehavior {

	private static short idSeed = 1;

	public static final short WaitT = 1;

	public static final short StartT = 2;

	public static final short TimeoutT = 3;

	private final BroadcastChannel start0;

	private final BroadcastChannel start1;

	private final BroadcastChannel stop0;

	private final BroadcastChannel stop1;

	private final BroadcastChannel timeout0;

	private final BroadcastChannel timeout1;

	private final WaitChannel wait0;

	private final Channel[] channels;

	public void collectChannels(List<Channel> result) {
		result.addAll(Arrays.asList(channels));
	}

	public Tim_2_2_2Behavior(SymbolsTable symbols, BroadcastChannel start0, BroadcastChannel start1, BroadcastChannel stop0, BroadcastChannel stop1, BroadcastChannel timeout0, BroadcastChannel timeout1) {
		super("tim_2_2_2", idSeed++, symbols);
		this.start0 = start0;
		this.start1 = start1;
		this.stop0 = stop0;
		this.stop1 = stop1;
		this.timeout0 = timeout0;
		this.timeout1 = timeout1;
		symbols.registerClockIndexes(this.getId(), (short) 1);
		
		wait0 = new WaitChannel(null, symbols, this.getId(), (short) 0, 1, false, 1, false);
		channels = new Channel[] { wait0,  };
	}

	private final String[] stateNames = new String[] {"waitT", "startT", "timeoutT"};

	public int getStateId(String name) {
		for (short i=0; i<stateNames.length; i++) {
			if ( stateNames[i].equals(name) ) return (i+1);
		}
		throw new IllegalArgumentException("State '"+ name +"' doesn't exist in process '"+ this.name +"'.");
	}

	public String getStateName(short id) {
		return stateNames[id-1];
	}

	private final Transition transition0 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return start0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != StartT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			start0.input(id, actions);
			me.delay = start0.value(int.class,0);
			if ( start0.clockId != -1 ) {
				DBM.set(configuration.dbm, start0.clockId, 0);
			}
			me.state = WaitT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition1 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return start1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != StartT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			start1.input(id, actions);
			me.delay = start1.value(int.class,0);
			if ( start1.clockId != -1 ) {
				DBM.set(configuration.dbm, start1.clockId, 0);
			}
			me.state = WaitT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition2 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return stop0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != WaitT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			stop0.input(id, actions);
			if ( stop0.clockId != -1 ) {
				DBM.set(configuration.dbm, stop0.clockId, 0);
			}
			me.state = StartT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition3 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Input;
		}

		@Override
		public short getSynchronisationChannelId() {
			return stop1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != WaitT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			stop1.input(id, actions);
			if ( stop1.clockId != -1 ) {
				DBM.set(configuration.dbm, stop1.clockId, 0);
			}
			me.state = StartT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition4 = 	new Transition(id) {
		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != WaitT) return false;
			if ( ((me.delay) < (1)) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			me.state = TimeoutT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition5 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return wait0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != WaitT) return false;
			if ( ( !((me.delay) < (1))) == false) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			DBM.set(configuration.dbm, wait0.clockId, 0);
			actions.add(new DelayAction(id));
			me.delay = (me.delay) - (1);
			me.state = WaitT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition6 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return timeout0.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != TimeoutT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			timeout0.output(id, actions);
			me.state = StartT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition transition7 = 	new Transition(id) {
		@Override
		public short getSynchronisationType() {
			return Output;
		}

		@Override
		public short getSynchronisationChannelId() {
			return timeout1.id;
		}

		@Override
		public boolean guard(Configuration configuration, ExplorationContext context) {
			Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			if (me.state != TimeoutT) return false;
			return true;
		}

		@Override
		public boolean action(final ExplorationContext context, List<AtomicAction> actions, Configuration configuration) {
			final Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) configuration.behaviorConfigurations[id];
			timeout1.output(id, actions);
			me.state = StartT;
			if (true) return true;
			if (true) { return true; } else { return true; }
		}

	}

;

	private final Transition[] transitions = 	new Transition[] {
		transition0,
		transition1,
		transition2,
		transition3,
		transition4,
		transition5,
		transition6,
		transition7,
	}
;

	@Override
	public Transition[] getTransitions(Configuration configuration) {
		return transitions;
	}

	@Override
	public BehaviorConfiguration createInitialConfiguration(Configuration conf) {
		Tim_2_2_2Configuration me = new Tim_2_2_2Configuration();
		//Initial action code.
		me.state = StartT;
		return me;
	}

	public String toStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("proc: ");
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Tim_2_2_2Behavior.WaitT: 
			text.append("@waitT,");
			break;
		case Tim_2_2_2Behavior.StartT: 
			text.append("@startT,");
			break;
		case Tim_2_2_2Behavior.TimeoutT: 
			text.append("@timeoutT,");
			break;
		}
		text.append("\n\t- delay=");
		text.append(Integer.toString(me.delay));
		text.append("\n]");
		return text.toString();
	}

	public String toDotStringConfiguration(BehaviorConfiguration behaviorConfiguration) {
		Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) behaviorConfiguration;
		StringBuilder text = new StringBuilder();
		text.append("'");
		text.append(name);
		text.append("' [");
		switch (me.state) {
		case Tim_2_2_2Behavior.WaitT: 
			text.append("@waitT,");
			break;
		case Tim_2_2_2Behavior.StartT: 
			text.append("@startT,");
			break;
		case Tim_2_2_2Behavior.TimeoutT: 
			text.append("@timeoutT,");
			break;
		}
		text.append(" delay=");
		text.append(Integer.toString(me.delay));
		text.append("]");
		return text.toString();
	}

	@Override
	public BehaviorConfiguration readConfiguration(Boost boost) {
		Tim_2_2_2Configuration me = new Tim_2_2_2Configuration();
		me.state = boost.readShort();
		me.delay = boost.readInt();
		return me;
	}

	@Override
	public void writeConfiguration(Boost boost, BehaviorConfiguration processConfiguration) {
		Tim_2_2_2Configuration me = (Tim_2_2_2Configuration) processConfiguration;
		boost.writeShort(me.state);
		boost.writeInt(me.delay);
	}

}

