package test.compiled.timer_flat;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel t2_start = new BroadcastChannel(name+":t2_start", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel t2_stop = new BroadcastChannel(name+":t2_stop", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel t2_timeout = new BroadcastChannel(name+":t2_timeout", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel t3_start = new BroadcastChannel(name+":t3_start", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel t3_stop = new BroadcastChannel(name+":t3_stop", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel t3_timeout = new BroadcastChannel(name+":t3_timeout", symbols, 1, 1, 0, false, 0, false);
		channels = new Channel[] { t2_start, t2_stop, t2_timeout, t3_start, t3_stop, t3_timeout,  };
		
		components = new Component[] {
				new PBehavior(symbols, t2_start, t2_stop, t2_timeout),
				new PBehavior(symbols, t3_start, t3_stop, t3_timeout),
				new TimerBehavior(symbols, t2_start, t2_stop, t2_timeout),
				new TimerBehavior(symbols, t3_start, t3_stop, t3_timeout)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

