package test.compiled.timer_shared;

import obp.explorer.runtime.core.Channel;
import obp.explorer.runtime.core.BroadcastChannel;
import obp.explorer.runtime.SymbolsTable;
import obp.explorer.runtime.Composition;
import obp.explorer.runtime.Component;

@SuppressWarnings("all")
public class MainComposition extends Composition {

	private static short idSeed = 1;

	private final Component[] components;

	private final Channel[] channels;

	public MainComposition(SymbolsTable symbols) {
		final String name = symbols.newComponentName("main", idSeed++);
		BroadcastChannel timStart0 = new BroadcastChannel(name+":timStart0", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timStop1 = new BroadcastChannel(name+":timStop1", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timTimeout2 = new BroadcastChannel(name+":timTimeout2", symbols, 1, 1, 0, false, 0, false);
		BroadcastChannel timTimeout3 = new BroadcastChannel(name+":timTimeout3", symbols, 1, 1, 0, false, 0, false);
		channels = new Channel[] { timStart0, timStop1, timTimeout2, timTimeout3,  };
		
		components = new Component[] {
				new PBehavior(symbols, timStart0, timTimeout2),
				new P1Behavior(symbols, timStop1, timTimeout3),
				new Tim_1_1_2Behavior(symbols, timStart0, timStop1, timTimeout2, timTimeout3)
			};
		
	}

	@Override
	public Component[] getComponents() {
		return components;
	}

	@Override
	public Channel[] getChannels() {
		return channels;
	}

}

